: Copyright 1987 Intel Corp.
# "@(#) blogin.B $State: XENIX_R3-5 $ $Date: 87/03/06 15:55:11 $"
# Author:  Ed Reeder, Intel Corporation
#
. /tmp/blog.$IPID	# get environment variables

# get time of last mtape operation (if any)
if [ -f $MIRROR ] ; then
   set X`ls -l $MIRROR`
   MDAY="$6 $7"
   MTIME=$8
   LASTOP="(Last Entire Disk operation was done on $MDAY	at $MTIME)"
else
   LASTOP=
fi

while :
   do
   echo $NEWPAGE
   cat  <<-HERE
---------------------------------------------------------------------(Login)
                Backup / Restore Login (V${VERSION})
                System Node name "$SYSID"
        $LASTOP


        BACKUP/RESTORE OPERATIONS:

        a)  Entire disk

        b)  Selected files


        q)  Quit, exit the Backup/Restore Login
        ?)  Get an explanation of these options






HERE
   echo -n "Enter selection? "
   read reply extra
   case "$reply" in
      a|A) # MIRROR IMAGE
         echo $NEWPAGE
         TYPE=MIRROR
         # make sure there is a cartridge tape, if not can't do mirror
         # (Note: test is somewhat bogus as /dev/rmt0 is nearly always built)
         if [ ! -c /dev/rmt0 ] ; then
            echo "
There is no cartridge tape defined for your system.  You cannot perform
Entire-Disk operations without one.\n
Press RETURN to continue. \c"
            read reply
            continue
         fi
         # see if any iDIS transactions exist
	 # (This can occur only on a standalone system or a sub-net master.)
         # NOTE: IF THERE WERE NONE DETECTED THEY WILL BE CHECKED ONCE MORE
         # LATER IN THE PROCEDURE.  JUST IN CASE SOME STARTED AFTER THIS
         # TEST AND BEFORE ALL PROCESSES WERE KILLED. 
         # SO IF YOU MAKE ANY CHANGES HERE, MAKE THEM THERE ALSO!!!

	 # does iDIS directory even exist?
         if [ ! -d $IDISTXN ] ; then
            IDIS=Y	# this will keep 2nd test from being applied
         else
            # see if any unfinished transactions exist
            TXNS=`ls $IDISTXN/*.apply/*.[0-9]* 2>/dev/null`
            if [ -z "$TXNS" ] ; then
               IDIS=N		# indicate none exist at present
            else
               while :
               do
                  echo $NEWPAGE
                  echo "
iDIS scheduled transactions exist. 

If you take an Entire-Disk backup now, problems may occur later when you
restore the disk.  What would happen then is that the scheduled transactions
would be run a second time.  This action could be disruptive to the system.

You may wish to check with your system administrator concerning the next step
to take.

Do you wish to continue, which could be disruptive (y or n)? \c"
                  read resp
                  case $resp in
                     y*|Y*) IDIS=Y	# keep 2nd test from being applied
			break ;;
                     n*|N*) exit ;;
                     *) echo "\nInvalid action <$resp>, Press RETURN to continue.\c"
                        read reply ;;
                  esac
               done
            fi
         fi
         # see if any iDIS logical network master transactions exist
	 # (This can occur only on a logical or a sub-net master.)
         # NOTE: IF THERE WERE NONE DETECTED THEY WILL BE CHECKED ONCE MORE
         # LATER IN THE PROCEDURE.  JUST IN CASE SOME STARTED AFTER THIS
         # TEST AND BEFORE ALL PROCESSES WERE KILLED. 
         # SO IF YOU MAKE ANY CHANGES HERE, MAKE THEM THERE ALSO!!!

	 # does ilna directory even exist?
         if [ ! -d $ILNATXN ] ; then
            ILNA=Y	# this will keep 2nd test from being applied
         else
            # see if any unfinished transactions exist
            TXNS=`ls $ILNATXN/*/* 2>/dev/null`
            if [ -z "$TXNS" ] ; then
               ILNA=N		# indicate none exist at present
            else
               while :
               do
                  echo $NEWPAGE
                  echo "
ilna (logical network master) transactions exist. 

If you take an Entire-Disk backup now, problems may occur later when you
restore the disk.  What would happen then is that the scheduled transactions
would be run a second time.  This action could be disruptive to the system.

You may wish to check with your system administrator concerning the next step
to take.

Do you wish to continue, which could be disruptive (y or n)? \c"
                  read resp
                  case $resp in
                     y*|Y*) ILNA=Y	# keep 2nd test from being applied
			break ;;
                     n*|N*) exit ;;
                     *) echo "\nInvalid action <$resp>, Press RETURN to continue.\c"
                        read reply ;;
                  esac
               done
            fi
         fi
         break
        ;;

      b|B) # INCREMENTAL
         echo $NEWPAGE
         TYPE=INCREMENTAL
         break
        ;;

      q*|Q*)
         echo $NEWPAGE
         exit 1
        ;;

      \?|help|Help)
        echo $NEWPAGE
        more -c $IBRPATH/blogin.0.hlp
        echo '* * Press RETURN to continue * *'
        read reply
        ;;

      *)
        echo "\nInvalid action <$reply>,  Press RETURN to continue."
        read reply
	echo $NEWPAGE
        ;;
   esac
done

echo $NEWPAGE
echo "
The system needs to be in a quiet state to ensure proper operation of the
backup/recovery functions.  It will be necessary to log out any currently
active users.  The users will be notified that the system is about to be
shut down.

You must provide the number of minutes that the users will be given to
clean up their present activities.

Once the system is quiet the backup/restore functions will continue.\n"

cat <<-HERE >> /tmp/blog.$IPID	# tell rest of scripts what selected
	TYPE=$TYPE
	ILNA=$ILNA
	iDIS=$iDIS
HERE

exit 0
