: Copyright 1987 Intel Corp.
# "@(#) blogin.C $State: XENIX_R3-5 $ $Date: 87/02/19 17:58:26 $"
# Author:  Ed Reeder, Intel Corporation
#
. /tmp/blog.$IPID	# get environment variables

if [ $TYPE = INCREMENTAL ] ; then
   # won't do fsck before incrementals.  It is possible that the clean up
   # of a file system could delete a file you want saved.
   echo $NEWPAGE
   /etc/ibr	# give control to the backup/restore script
   SU=Y		# just go into single-user mode
else
   # MIRROR
   # set default actions, assume not going to quit because of iDIS txns.
   SU=N			# go all the way down
   TOUCH="touch $MIRROR"	# indicate mirror dump time
   # if there weren't any txns before, see if any iDIS txns now exist
   # (This can occur only on a standalone system or a sub-net master.)
   if [ "$IDIS" = N ] ; then
      # see if any unfinished transactions exist
      TXNS=`ls $IDISTXN/*.apply/*.[0-9]* 2>/dev/null`
      if [ -z "$TXNS" ] ; then
         : O.K.
      else
         while :
         do
            echo $NEWPAGE
            echo "
iDIS scheduled transactions exist. 

If you take an Entire-Disk backup now, problems may occur later when you
restore the disk.  What would happen then is that the scheduled transactions
would be run a second time.  This action could be disruptive to the system.

If you perform an Entire-Disk restore now, you will lose the scheduled
transactions.

You may wish to check with your system administrator concerning the next step
to take.

Do you wish to continue, which could be disruptive (y or n)? \c"
            read resp
            case $resp in
              y*|Y*) break ;;
              n*|N*) 
                 echo "Backup/Restore canceled."
                 SU=Y			# only go into single user mode
                 TOUCH=
                 break
              ;;
              *) echo "\nInvalid action <$resp>, Press RETURN to continue.\c"
                 read reply ;;
            esac
         done
      fi
   fi
   # if there weren't any txns before and haven't said previously not to
   # continue, see if any ilna txns now exist
   # (This can occur only on a network or a sub-net master.)
   if [ "$ILNA" = N -a "$1" != su ] ; then
      # see if any unfinished transactions exist
      TXNS=`ls $ILNATXN/*/* 2>/dev/null`
      if [ -z "$TXNS" ] ; then
         : O.K.
      else
         while :
         do
            echo $NEWPAGE
            echo "
ilna (logical network master) transactions exist. 

If you take an Entire-Disk backup now, problems may occur later when you
restore the disk.  What would happen then is that the scheduled transactions
would be run a second time.  This action could be disruptive to the system.

If you perform an Entire-Disk restore now, you will lose the scheduled
transactions.

You may wish to check with your system administrator concerning the next step
to take.

Do you wish to continue, which could be disruptive (y or n)? \c"
            read resp
            case $resp in
              y*|Y*) break ;;
              n*|N*) 
                 echo "Backup/Restore canceled."
                 SU=Y			# only go into single user mode
                 TOUCH=
                 break
              ;;
              *) echo "\nInvalid action <$resp>, Press RETURN to continue.\c"
                 read reply ;;
            esac
         done
      fi
   fi
   eval $TOUCH		# touch file as appropriate
fi # end of $TYPE if

# Indicate whether to go into standalone or all the way down
case $SU in
   Y) exit 128 ;;
   N) exit 129 ;;
esac
