/*
 *	INTEL CORPORATION PROPRIETARY INFORMATION
 *
 *	This software is supplied under the terms
 *	of a license agreement or nondisclosure
 *	agreement with Intel Corporation and may
 *	not be copied nor disclosed except in
 *	accordance with the terms of that agreement.
 */

/******************************************************************************
 *
 *	"@(#) c215.boot $State: XENIX_R3-5_U2 $ $Date: 88/02/19 14:53:25 $";
 *
 *		All functional and historical information should be
 *		maintained in cfgi215.sh. Note that this file is
 *		DIFFERENT than c215g.c produced by cfgi215. This file
 *		should be used when building boot floppies which need
 *		to work on either 5 1/4 or 8 inch floppy media.
 *
 *	I000 - sjg	06/10/86
 *		changed ram partition on 5 1/4 inch from 112 to 128 to
 *		match that generated by cfgi215, and to take advantage of
 *		extra space available with new boot memory layout
 *****************************************************************************/

#define		CMI10MB		0
#define		CMI15MB		0
#define		QNTM36MB	1
#define		PRIAM32		0
#define		PRIAM62		0
#define		MXTR72		0
#define		MXTR89		0
#define		MXTR121		0
#define		TSBA75		0
#define		SEAG43		0
#define		MXTR150		0
#define		MXTR323		0

/*-----------------------------------------------------------------*
 * The next line is used for MS-DOS partitioning.  It defines the  *
 * number of blocks to reserve for the MS-DOS partition            *
 *-----------------------------------------------------------------*/
#define	MSDOS		0

/*
 * Number of blocks in the root file system.
 * Adds capability to install on different sizes of
 * root partition when updating existing file systems.
 * New default is for 9 Meg Byte root partition.
 * This assumes 9 sectors/track comes out on a track boundary.
 * Obviously this may not be true for all drives.
 */
#define	ROOTBLKS	9216

#include "../h/param.h"
#include "../h/buf.h"
#include "../h/iobuf.h"
#include "../h/i215g.h"

#if CMI10MB
#  define SECTORS 9
#  define BYTES 1024
#  define CYLINDERS 306
#  define HEADS 4
#  define INTLV 4
#  define PERIPHS 5
#  define SWPSIZE 1188
#  define RTCGSZ 3172
#  define RTXTENT 8
#  define i215TYPE DEVWINIG
#  define FLPYTYPE DEV5FLPY
#  define TAPETYPE STREAMER
#endif CMI10MB
#if CMI15MB
#  define SECTORS 9
#  define BYTES 1024
#  define CYLINDERS 306
#  define HEADS 6
#  define INTLV 4
#  define PERIPHS 5
#  define SWPSIZE 1188
#  define RTCGSZ 2978
#  define RTXTENT 8
#  define i215TYPE DEVWINIG
#  define FLPYTYPE DEV5FLPY
#  define TAPETYPE STREAMER
#endif CMI15MB
#if QNTM36MB
#  define SECTORS 9
#  define BYTES 1024
#  define CYLINDERS 512
#  define HEADS 8
#  define INTLV 4
#  define PERIPHS 5
#  define SWPSIZE 4104
#  define RTCGSZ 3072
#  define USRCGSZ 3238
#  define RTXTENT 8
#  define USRXTENT 8
#  define i215TYPE DEVWINIG
#  define FLPYTYPE DEV5FLPY
#  define TAPETYPE STREAMER
#endif QNTM36MB
#if PRIAM32
#  define SECTORS 12
#  define BYTES 1024
#  define CYLINDERS 525
#  define HEADS 5
#  define INTLV 4
#  define PERIPHS 8
#  define SWPSIZE 4104
#  define RTCGSZ 3072
#  define USRCGSZ 2906
#  define RTXTENT 8
#  define USRXTENT 8
#  define i215TYPE DEVWINI
#  define FLPYTYPE DEV8FLPY
#  define TAPETYPE INVALID
#endif PRIAM32
#if PRIAM62
#  define SECTORS 12
#  define BYTES 1024
#  define CYLINDERS 1050
#  define HEADS 5
#  define INTLV 4
#  define PERIPHS 8
#  define SWPSIZE 8208
#  define RTCGSZ 3072
#  define USRCGSZ 3398
#  define RTXTENT 8
#  define USRXTENT 8
#  define i215TYPE DEVWINI
#  define FLPYTYPE DEV8FLPY
#  define TAPETYPE INVALID
#endif PRIAM62
#if MXTR72
#  define SECTORS 9
#  define BYTES 1024
#  define CYLINDERS 1024
#  define HEADS 8
#  define INTLV 4
#  define PERIPHS 5
#  define SWPSIZE 9216
#  define RTCGSZ 3072
#  define USRCGSZ 3580
#  define RTXTENT 8
#  define USRXTENT 8
#  define i215TYPE DEVWINIG
#  define FLPYTYPE DEV5FLPY
#  define TAPETYPE STREAMER
#endif MXTR72
#if MXTR89
#  define SECTORS 9
#  define BYTES 1024
#  define CYLINDERS 918
#  define HEADS 11
#  define INTLV 4
#  define PERIPHS 5
#  define SWPSIZE 16416
#  define RTCGSZ 3072
#  define USRCGSZ 3722
#  define RTXTENT 8
#  define USRXTENT 8
#  define i215TYPE DEVWINIG
#  define FLPYTYPE DEV5FLPY
#  define TAPETYPE STREAMER
#endif MXTR89
#if MXTR121
#  define SECTORS 9
#  define BYTES 1024
#  define CYLINDERS 918
#  define HEADS 15
#  define INTLV 4
#  define PERIPHS 5
#  define SWPSIZE 16416
#  define RTCGSZ 3072
#  define USRCGSZ 4156
#  define RTXTENT 8
#  define USRXTENT 8
#  define i215TYPE DEVWINIG
#  define FLPYTYPE DEV5FLPY
#  define TAPETYPE STREAMER
#endif MXTR121
#if TSBA75
#  define SECTORS 9
#  define BYTES 1024
#  define CYLINDERS 830
#  define HEADS 10
#  define INTLV 4
#  define PERIPHS 5
#  define SWPSIZE 9216
#  define RTCGSZ 3072
#  define USRCGSZ 3642
#  define RTXTENT  8
#  define USRXTENT 8
#  define i215TYPE DEVWINIG
#  define FLPYTYPE DEV5FLPY
#  define TAPETYPE STREAMER
#endif TSBA75
#if SEAG43
#  define SECTORS 9
#  define BYTES 1024
#  define CYLINDERS 820
#  define HEADS 6
#  define INTLV 4
#  define PERIPHS 5
#  define SWPSIZE 4104
#  define RTCGSZ 3072
#  define USRCGSZ 3330
#  define RTXTENT  8
#  define USRXTENT 8
#  define i215TYPE DEVWINIG
#  define FLPYTYPE DEV5FLPY
#  define TAPETYPE STREAMER
#endif SEAG43
#if MXTR150
#  define SECTORS 18
#  define BYTES 1024
#  define CYLINDERS 1223
#  define HEADS 7
#  define INTLV 1
#  define PERIPHS 5
#  define SWPSIZE 16416
#  define RTCGSZ 3072
#  define USRCGSZ 4636
#  define RTXTENT 8
#  define USRXTENT 8
#  define USRINODES 4
#  define i215TYPE DEVWINIG
#  define FLPYTYPE DEV5FLPY
#  define TAPETYPE STREAMER
#endif MXTR150
#if MXTR323
#  define SECTORS 18
#  define BYTES 1024
#  define CYLINDERS 1223
#  define HEADS 15
#  define INTLV 1
#  define PERIPHS 5
#  define SWPSIZE 16416
#  define RTCGSZ 3072
#  define USRCGSZ 6612
#  define RTXTENT 8
#  define USRXTENT 8
#  define USRINODES 8
#  define i215TYPE DEVWINIG
#  define FLPYTYPE DEV5FLPY
#  define TAPETYPE STREAMER
#endif MXTR323

/*----------------------------------------*
 * STREAMER Tape Partition Table (dummy). *
 *----------------------------------------*/
struct	i215part Mmt0[] = {
	0,		0			/* Archive streamer	*/
};

/*----------------------------------------------------------------------*
 * 215 Board 0 unit 8 (Tape) Device-Table Definitions (drtabs)		*
 *									*
 * Note: Tape is treated differently from disk.				*
 *	Formatting a tape unit will cause the Tape to be erased.	*
 *	Sector Size refers to the block size of the tape device.	*
 *	#Sec (Number of sectors per Track) is the Number of Blocks	*
 *	per Tape.  Streamer Tapes (Archive) Must be blocked in a	*
 *	multiple of the on board buffer size (512 bytes).		*
 *----------------------------------------------------------------------*/

struct	i215cdrt i215t00[] = {
/* unit-present, no-op, no-op, no-op, no-op, !rew?, Part, NoPrt.	*/
  01,		0,	0,	0,	0,	0, Mmt0, 0, /* [0]: Streamer  */
  01,		0,	0,	0,	0,	1, Mmt0, 0  /* [1]: No rewind */
};

/*
 * Floppy Partitions.
 *	Note: It is possible to use i215minor to specify combinations
 *	of i215cdrt and i215part entries that do not make sense.  The
 *	standard configurations should use the same index for each and
 *	keep the two tables in the same order.
*/
struct	i215part Pf0[] = {
#if PERIPHS == 8			/* 8 in. System */
	8,	1224,	/* [0] (minor 07) dnf0	Track 1 through rest: 608K  */
	8,	608,	/* [1] (minor 08) f0	Track 1 through rest: 1224K */
	0,	2002,	/* [2] (minor 09) syf0	all of disk: 250K  */
	26,	3978,	/* [3] (minor 10) dxf0	Track 1-rest: 994.5K */
	8,	1224,	/* [4] (minor 11) df0	Track 1 through rest: 1224K */
	26,	780,	/* [5] (minor 12) boot	780 sectors: 195k */
	806,	832	/* [6] (minor 13) ram	832 sectors: 208k */
#else					/* 5.25 System */
	8,	632,	/* [0] (minor 07) dnf0	RMX         format	*/
	4,	316,	/* [1] (minor 08) df0	Xenix R1    format	*/
	0,	640,	/* [2] (minor 09) syf0	bootstrap   format	*/
	0,	640,	/* [3] (minor 10) dzf0	MSDOS R1    format	*/
	0,	720,	/* [4] (minor 11) dvf0	MSDOS R2    format	*/
	8,	184,	/* [5] (minor 12) boot	boot floppy format	*/
	192,	128	/* [6] (minor 13) ram	boot floppy format	*/
#endif	PERIPHS
};

/*
 * Floppy Device-Table Definitions (drtabs)
 *	Note: It is possible to use i215minor to specify combinations
 *	of i215cdrt and i215part entries that do not make sense.  The
 *	standard configurations should use the same index for each and
 *	keep the two tables in the same order.  If we plan this out for
 *	the next release, maybe we can bring minor and function and name
 *	into agreement, so one /dev/makefile entry would suffice.
*/
struct	i215cdrt i215f00[] = {
#if PERIPHS == 8			/* 8 in. System */
/*Cyls, Fixed, Remov,  #Sec,  SecSiz, Nalt, Part , NoPrt  Unit: Drive-Type */
  77,	0,	2,	8,	1024, FLPY_MFM, Pf0, 0, /* [0] dvf0 [07] */
  77,	0,	1,	8,	1024, FLPY_MFM, Pf0, 0, /* [1] f0   [08] */
  77,	0,	1,	26,	128,  FLPY_FM,  Pf0, 0, /* [2] syf0 [09] */
  77,	0,	2,	26,	256,  FLPY_MFM, Pf0, 0, /* [3] dxf0 [10] */
  77,	0,	2,	8,	1024, FLPY_MFM, Pf0, 0, /* [4] df0  [11] */
  77,	0,	2,	26,	256,  FLPY_MFM, Pf0, 0, /* [5] boot [12] */
  77,	0,	2,	26,	256,  FLPY_MFM, Pf0, 0  /* [6] ram  [13] */
#else					/* 5.25 System */
/*Cyls, Fixed, Remov,  #Sec,  SecSiz,  Nalt, Part, NoPrt  Unit: Drive-Type */
  40,	0,	2,	8,	512,  FLPY_MFM,	Pf0, 0, /* [0] dnf0 [07]	*/
  40,	0,	2,	4,	1024, FLPY_MFM, Pf0, 0, /* [1] df0  [08]	*/
  40,	0,	1,	16,	128,  FLPY_FM,  Pf0, 0, /* [2] syf0 [09]	*/
  40,	0,	2,	8,	512,  FLPY_MFM, Pf0, 0, /* [3] dzf0 [10]	*/
  40,	0,	2,	9,	512,  FLPY_MFM, Pf0, 0, /* [4] dvf0 [11]	*/
  40,	0,	2,	4,	1024, FLPY_MFM, Pf0, 0, /* [5] boot [12]	*/
  40,	0,	2,	4,	1024, FLPY_MFM, Pf0, 0  /* [6] ram  [13]	*/
#endif	PERIPHS
};

#define CYLSIZ	(HEADS*SECTORS)
#define DISKSIZ	(CYLINDERS*CYLSIZ-CYLSIZ)
#define W_ALTS	((CYLINDERS)/50)
#define DIAGSIZ	(W_ALTS*CYLSIZ+CYLSIZ)
#define UNXENIX (DIAGSIZ+(MSDOS*CYLSIZ))				/*I005*/

#ifndef USRCGSZ
#  define ROOTSIZ (DISKSIZ-UNXENIX-SWPSIZE-2*SECTORS)
#  define RESTSIZ 0		/* For mountable second drive partition	*/
#else
#  define ROOTSIZ ROOTBLKS
#  define RESTSIZ (DISKSIZ-UNXENIX-SWPSIZE-ROOTSIZ-2*SECTORS)
#endif
#  define NOPRT   7

/*
 * Winchester Partitions.
 * Note: Piw0[0] is the entire disk (except for the diagnostic cylinder).
 *	 This includes the alternate-track cylinders and the bad-track data.
 *	 Piw0[1-6] do not address this data.
*/
struct	i215part Piw0[] = {
	0,			DISKSIZ,	/* [0] whole disk	*/
	SECTORS,		ROOTSIZ,	/* [1] "root"		*/
	ROOTSIZ+SECTORS,	SWPSIZE,	/* [2] "swap"		*/
	SWPSIZE+ROOTSIZ+SECTORS, RESTSIZ,	/* [3] "rest"		*/
	SECTORS,		RESTSIZ+SWPSIZE+ROOTSIZ,
						/* [4] mountable device	*/
	DISKSIZ-UNXENIX,	MSDOS*CYLSIZ,	/* [5] "MS-DOS"		*/
	SWPSIZE+ROOTSIZ+SECTORS+RESTSIZ, SECTORS/* [6] "error"		*/
};

/*
 * Winchester Device-Table Definitions (drtab's)
*/
struct	i215cdrt i215d00[] = {
	CYLINDERS, HEADS, 0, SECTORS, 1024, W_ALTS, Piw0, NOPRT
};

/*
 * 215 Board configuration.
 *
 * Each structure in this array configures one controller board.  This
 * table specifies the wake-up blocks, and per-controller data-structures
 * for each 218 or 220 controller.
 *
*/
struct	i215cfg	 i215cfg[] = {
/* WUA, DevCode[0], [1],       [2],   Int,	Device Table[unit] */
0x01000L, i215TYPE, FLPYTYPE, TAPETYPE, 5,	i215d00,/* Wini 0 */
						0,	/* Wini 1 */
						0,	/* Wini 2 */
						0,	/* Wini 3 */
						i215f00,/* Floppy 0 */
						0,	/* Floppy 1 */
						0,	/* Floppy 2 */
						0,	/* Floppy 3 */
						i215t00,/* Tape 0 */
						0,	/* Tape 1 */
						0,	/* Tape 2 */
						0,	/* Tape 3 */
};

/*
 * i215minor
 *
 * This structure is used to widen the minor number information.
 *
 * This table configures the board number, partition number, drtab number
 * and unit number.  Since these are implemented with 4 bit fields, beware
 * of the C restrictions described in The C Programming Language book by
 * Kernighan/Ritchie (6.7 Fields).
 *
 * I215MINOR is a macro which encodes the board, unit, drtab, and partition
 * table indices into the internal representation of the bitfield.  It is
 * defined in ../h/i215g.h, and is not portable.
 *
 * Usage:
 *	I215MINOR(board, unit, drtab, partition),
*/
unsigned i215minor[] = {			/* [minor] device */
	i215MINOR(0,0,0,0),			/* [0] Wini format disk	 */
	i215MINOR(0,0,0,1),			/* [1] Wini root part	 */
	i215MINOR(0,0,0,2),			/* [2] Wini swap part	 */
	i215MINOR(0,0,0,3),			/* [3] Wini usr  part	 */
	i215MINOR(0,0,0,6),			/* [4] Wini error part	 */
	i215MINOR(0,0,0,4),			/* [5] Wini whole disk	 */
	i215MINOR(0,0,0,5),			/* [6] Wini MS-DOS part	 */
	i215MINOR(0,4,0,0),			/* [7]	dnf0/dvf0 floppy */
	i215MINOR(0,4,1,1),			/* [8]  df0/f0	  floppy */
	i215MINOR(0,4,2,2),			/* [9]  syf0	  floppy */
	i215MINOR(0,4,3,3),			/* [10] dzf0/dxf0 floppy */
	i215MINOR(0,4,4,4),			/* [11] dvf0/df0  floppy */
	i215MINOR(0,4,5,5),			/* [12] root	  floppy */
	i215MINOR(0,4,6,6),			/* [13] ram	  floppy */
	i215MINOR(4,8,0,0),			/* [14] tape reserved	 */
	i215MINOR(4,8,1,0),			/* [15] tape reserved	 */
	i215MINOR(0,8,0,0),			/* [16] smt0 st rewind   */
	i215MINOR(0,8,1,0),			/* [17] smnt0 st no-rew  */
	i215MINOR(4,0,0,0),			/* [18] Reserved	 */
	i215MINOR(4,0,0,0),			/* [19] Reserved	 */
};

/*
 *	Number of retries in case of soft error (configurable).
*/
int i215retry = 10;

/*
 * Note: 215/218,220 boards MUST have contiguous major numbers AND have
 *	 same 1st index in bdevsw[] & cdevsw[].
*/
int	i215fmaj = 0;				/* 1st {b,c}devsw index */

/*
 * The following are static initialization variables
 * which are based on the configuration. These variables
 * MUST NOT CHANGE because the i215 device driver makes
 * most of the calculations based on these variables.
*/
#define	NUM215	((sizeof i215cfg) / (sizeof (struct i215cfg)))
int    N215 =   NUM215;			/* number of configured boards   */
struct iobuf    i215tab[NUM215];	/* buffer headers per board      */
struct iobuf    i215tbuf[NUM215];	/* I015 tape buffer headers per board */
struct buf      i215rbuf[NUM215];	/* raw buffer headers per board  */
struct i215dev *i215bdd[NUM215];	/* board-idx -> "dev" map        */
struct i215dev  i215dev[NUM215];	/* per-board data-structures     */
short  i215maxmin = ((sizeof i215minor)/(sizeof (struct i215minor)));
					/* maximum minor number posible. */

#define	i215TMEM	8		/* The number of external buffers */
int i215tbuf_max = i215TMEM;		/* The maximum number to allocate */
struct i215tmem i215tmem[i215TMEM+1];	/* external buffer structures */

#ifdef BBFAKE
/***********************************************************************
		i025 DEBUGGING
*/

struct i215_bb_fake i215fake[3] = {
	-1L,	-1,	ST_HARD_ERR,	HARD_NO_SECTOR,
	-1L,	-1,	ST_HARD_ERR,	HARD_NO_SECTOR,
	-1L,	-1,	ST_HARD_ERR,	HARD_NO_SECTOR
};

int	i215_bb_max = 3;

/*
	END i025 DEBUGGING
************************************************************************/
#endif BBFAKE

