/*
 *	INTEL CORPORATION PROPRIETARY INFORMATION
 *
 *	This software is upplied under the terms
 *	of a license agreement or nondisclosure
 *	agreement with Intel Corporation and may
 *	not be copied nor disclosed except in
 *	accordance with the terms of that agreement.
 */

/******************************************************************************
 *
 *	@(#) cfgi215 $State: XENIX_R3-5 $ $Date: 87/07/20 16:51:42 $
 *
 *		All functional and historical information should be
 *		maintained in cfgi215. Note that this file (c215g.c) is
 *		DIFFERENT than the one produced from the c215.boot file.
 *		This file should NOT be used when building boot floppies
 *		which need to work on either 5 1/4 or 8 inch floppy media.
 *
 *****************************************************************************/

#define		CMI10MB	0
#define		CMI15MB	0
#define		QNTM36MB	1
#define		PRIAM32	0
#define		PRIAM62	0
#define		MXTR72	0
#define		MXTR89	0
#define		MXTR121	0
#define		TSBA75	0
#define		SEAG43	0
#define		MXTR150	0
#define		MXTR323	0

/*-----------------------------------------------------------------*
 * The next line is used for MS-DOS partitioning.  It defines the  *
 * number of blocks to reserve for the MS-DOS partition            *
 *-----------------------------------------------------------------*/
#define	MSDOS			0

/*
 * Number of blocks in the root file system. Adds capability
 * to allow installation on different sizes of root partition
 * when updating existing file systems.
 * New default is for 9 Meg Byte root partition. This assumes
 * 9 sectors per track to come out on a track boundary. Obviously
 * this may not be true for all drives.
 */
#define	ROOTBLKS	9216

#include "../h/param.h"
#include "../h/buf.h"
#include "../h/iobuf.h"
#include "../h/i215g.h"

#if CMI10MB
#  define SECTORS 9L
#  define BYTES 1024L
#  define CYLINDERS 306L
#  define HEADS 4L
#  define INTLV 4L
#  define PERIPHS 5L
#  define SWPSIZE 1188L
#  define RTCGSZ 3172L
#  define RTXTENT 8L
#endif CMI10MB
#if CMI15MB
#  define SECTORS 9L
#  define BYTES 1024L
#  define CYLINDERS 306L
#  define HEADS 6L
#  define INTLV 4L
#  define PERIPHS 5L
#  define SWPSIZE 1188L
#  define RTCGSZ 2978L
#  define RTXTENT 8L
#endif CMI15MB
#if QNTM36MB
#  define SECTORS 9L
#  define BYTES 1024L
#  define CYLINDERS 512L
#  define HEADS 8L
#  define INTLV 4L
#  define PERIPHS 5L
#  define SWPSIZE 4104L
#  define RTCGSZ 3072L
#  define USRCGSZ 3238L
#  define RTXTENT 8L
#  define USRXTENT 8L
#endif QNTM36MB
#if PRIAM32
#  define SECTORS 12L
#  define BYTES 1024L
#  define CYLINDERS 525L
#  define HEADS 5L
#  define INTLV 4L
#  define PERIPHS 8L
#  define SWPSIZE 4104L
#  define RTCGSZ 3072L
#  define USRCGSZ 2906L
#  define RTXTENT 8L
#  define USRXTENT 8L
#endif PRIAM32
#if PRIAM62
#  define SECTORS 12L
#  define BYTES 1024L
#  define CYLINDERS 1049L
#  define HEADS 5L
#  define INTLV 4L
#  define PERIPHS 8L
#  define SWPSIZE 8208L
#  define RTCGSZ 3072L
#  define USRCGSZ 3398L
#  define RTXTENT 8L
#  define USRXTENT 8L
#endif PRIAM62
#if MXTR72
#  define SECTORS 9L
#  define BYTES 1024L
#  define CYLINDERS 1024L
#  define HEADS 8L
#  define INTLV 4L
#  define PERIPHS 5L
#  define SWPSIZE 9216L
#  define RTCGSZ 3072L
#  define USRCGSZ 3580L
#  define RTXTENT 8L
#  define USRXTENT 8L
#endif MXTR72
#if MXTR89
#  define SECTORS 9L
#  define BYTES 1024L
#  define CYLINDERS 918L
#  define HEADS 11L
#  define INTLV 4L
#  define PERIPHS 5L
#  define SWPSIZE 16416L
#  define RTCGSZ 3072L
#  define USRCGSZ 3722L
#  define RTXTENT 8L
#  define USRXTENT 8L
#endif MXTR89
#if MXTR121
#  define SECTORS 9L
#  define BYTES 1024L
#  define CYLINDERS 918L
#  define HEADS 15L
#  define INTLV 4L
#  define PERIPHS 5L
#  define SWPSIZE 16416L
#  define RTCGSZ 3072L
#  define USRCGSZ 4156L
#  define RTXTENT 8L
#  define USRXTENT 8L
#endif MXTR121
#if TSBA75
#  define SECTORS 9L
#  define BYTES 1024L
#  define CYLINDERS 830L
#  define HEADS 10L
#  define INTLV 4L
#  define PERIPHS 5L
#  define SWPSIZE 9216L
#  define RTCGSZ 3072L
#  define USRCGSZ 3642L
#  define RTXTENT 8L
#  define USRXTENT 8L
#endif TSBA75
#if SEAG43
#  define SECTORS 9L
#  define BYTES 1024L
#  define CYLINDERS 820L
#  define HEADS 6L
#  define INTLV 4L
#  define PERIPHS 5L
#  define SWPSIZE 4104L
#  define RTCGSZ 3072L
#  define USRCGSZ 3330L
#  define RTXTENT 8L
#  define USRXTENT 8L
#endif SEAG43
#if MXTR150
#  define SECTORS 18L
#  define BYTES 1024L
#  define CYLINDERS 1223L
#  define HEADS 7L
#  define INTLV 1L
#  define PERIPHS 5L
#  define SWPSIZE 16416L
#  define RTCGSZ 3072L
#  define USRCGSZ 4636L
#  define RTXTENT 8L
#  define USRXTENT 8L
#  define USRINODES 4L
#endif MXTR150
#if MXTR323
#  define SECTORS 18L
#  define BYTES 1024L
#  define CYLINDERS 1223L
#  define HEADS 15L
#  define INTLV 1L
#  define PERIPHS 5L
#  define SWPSIZE 16416L
#  define RTCGSZ 3072L
#  define USRCGSZ 6612L
#  define RTXTENT 8L
#  define USRXTENT 8L
#  define USRINODES 8L
#endif MXTR323

/*----------------------------------------*
 * STREAMER Tape Partition Table (dummy). *
 *----------------------------------------*/
struct	i215part Mmt0[] = {
	0,		0			/* Archive streamer	*/
};

/*----------------------------------------------------------------------*
 * 215 Board 0 unit 8 (Tape) Device-Table Definitions (drtabs)		*
 *									*
 * Note: Tape is treated differently from disk.				*
 *	Formating a tape unit will cause the Tape to be erased.		*
 *	Sector Size refers to the block size of the tape device.	*
 *	#Sec (Number of sectors per Track) is the Number of Blocks	*
 *	per Tape.  Streamer Tapes (Archive) Must be blocked in a	*
 *	multiple of the on board buffer size (512 bytes).		*
 *----------------------------------------------------------------------*/
struct	i215cdrt i215t00[] = {
/* unit-present, no-op, no-op, no-op, no-op, !rew?, Part, NoPrt		*/
  01,		0,	0,	0,	0,	0, Mmt0,   0,  /* [0]: Streamer  */
  01,		0,	0,	0,	0,	1, Mmt0,   0   /* [1]: No rewind */
};

/*
 * Floppy Partitions.
 *	Note: It is possible to use i215minor to specify combinations
 *	of i215cdrt and i215part entries that do not make sense.  The
 *	standard configurations should use the same index for each and
 *	keep the two tables in the same order.
*/
struct	i215part Pf0[] = {
	8,	632,	/* [0] (minor 07) dnf0	RMX         format	*/
	4,	316,	/* [1] (minor 08) df0	Xenix R1    format	*/
	0,	640,	/* [2] (minor 09) syf0	bootstrap   format	*/
	0,	640,	/* [3] (minor 10) dzf0	MSDOS R1    format	*/
	0,	720,	/* [4] (minor 11) dvf0	MSDOS R2    format	*/
	8,	184,	/* [5] (minor 12) boot	boot floppy format	*/
	192,	128	/* [6] (minor 13) ram	boot floppy format	*/
};

/*
 * Floppy Device-Table Definitions (drtabs)
 *	Note: It is possible to use i215minor to specify combinations
 *	of i215cdrt and i215part entries that do not make sense.  The
 *	standard configurations should use the same index for each and
 *	keep the two tables in the same order.  If we plan this out for
 *	the next release, maybe we can bring minor and function and name
 *	into agreement, so one /dev/makefile entry would suffice.
*/
struct	i215cdrt i215f00[] = {
/*Cyls, Fixed, Remov,  #Sec,  SecSiz,  Nalt,  Part, NoPrt  Unit: Drive-Type */
  40,	0,	2,	8,	512,  FLPY_MFM,	Pf0, 0,  /* [0] dnf0 [07] */
  40,	0,	2,	4,	1024, FLPY_MFM, Pf0, 0,  /* [1] df0  [08] */
  40,	0,	1,	16,	128,  FLPY_FM,  Pf0, 0,  /* [2] syf0 [09] */
  40,	0,	2,	8,	512,  FLPY_MFM, Pf0, 0,  /* [3] dzf0 [10] */
  40,	0,	2,	9,	512,  FLPY_MFM, Pf0, 0,  /* [4] dvf0 [11] */
  40,	0,	2,	4,	1024, FLPY_MFM, Pf0, 0,  /* [5] boot [12] */
  40,	0,	2,	4,	1024, FLPY_MFM, Pf0, 0   /* [6] ram  [13] */
};

#define CYLSIZ	(HEADS*SECTORS)
#define DISKSIZ	(CYLINDERS*CYLSIZ-CYLSIZ)
#define W_ALTS	(((CYLINDERS*HEADS)/50)/HEADS)
#define DIAGSIZ	(W_ALTS*CYLSIZ+CYLSIZ)

/*
 *	MS-DOS Release 1 reserves 14 cylinders for alternates.  The Release
 *	2 BIOS uses the same formula as Xenix uses (see W_ALTS above).  The
 *	Release 1 MS-DOS can be configured by a #define for OLDDOS.
*/
#ifdef OLDDOS
   /*
    *	The number 15 below is 14 alternates plus a cylinder for the bad
    *	track table.
   */
#  define UNXENIX ((MSDOS+15)*CYLSIZ)
#else
#  define UNXENIX (DIAGSIZ+(MSDOS*CYLSIZ))
#endif

#ifndef USRCGSZ
#  define ROOTSIZ (DISKSIZ-UNXENIX-SWPSIZE-2*SECTORS)
#  define RESTSIZ 0		/* For mountable second drive partition	*/
#else
#  define ROOTSIZ ROOTBLKS
#  define RESTSIZ (DISKSIZ-UNXENIX-SWPSIZE-ROOTSIZ-2*SECTORS)
#endif
#  define NOPRT   7

/*
 * Winchester Partitions.
 * Note: Piw0[0] is the entire disk (except for the diagnostic cylinder).
 *	 This includes the alternate-track cylinders and the bad-track data.
 *	 Piw0[1-6] do not address this data.
*/
struct	i215part Piw0[] = {
	0,			DISKSIZ,	/* [0] whole disk	*/
	SECTORS,		ROOTSIZ,	/* [1] "root"		*/
	ROOTSIZ+SECTORS,	SWPSIZE,	/* [2] "swap"		*/
	SWPSIZE+ROOTSIZ+SECTORS, RESTSIZ,	/* [3] "rest"		*/
	SECTORS,		RESTSIZ+SWPSIZE+ROOTSIZ,
						/* [4] mountable device	*/
	DISKSIZ-UNXENIX,	MSDOS*CYLSIZ,	/* [5] "MS-DOS"		*/
	SWPSIZE+ROOTSIZ+SECTORS+RESTSIZ, SECTORS/* [6] "error"		*/
};

/*
 * Winchester Device-Table Definitions (drtab's)
*/
struct	i215cdrt i215d00[] = {
	CYLINDERS, HEADS, 0, SECTORS, 1024, W_ALTS, Piw0, NOPRT
};

/*
 * 215 Board configuration.
 *
 * Each structure in this array configures one controller board.  This
 * table specifies the wake-up blocks, and per-controller data-structures
 * for each 218 or 220 controller.
 *
*/
struct	i215cfg	 i215cfg[] = {
/* WUA, DevCode[0], [1],       [2],   Int,	Device Table[unit] */
0x01000L, DEVWINIG, DEV5FLPY, STREAMER, 5,	i215d00,/* Wini 0 */
						0,	/* Wini 1 */
						0,	/* Wini 2 */
						0,	/* Wini 3 */
						i215f00,/* Floppy 0 */
						0,	/* Floppy 1 */
						0,	/* Floppy 2 */
						0,	/* Floppy 3 */
						i215t00,/* Tape 0 */
						0,	/* Tape 1 */
						0,	/* Tape 2 */
						0,	/* Tape 3 */
};

/*
 * i215minor
 *
 * This structure is used to widen the minor number information.
 *
 * This table configures the board number, partition number, drtab number
 * and unit number.  Since these are implemented with 4 bit fields, beware
 * of the C restrictions described in The C Programming Language book by
 * Kernighan/Ritchie (6.7 Fields).
 *
 * I215MINOR is a macro which encodes the board, unit, drtab, and partition
 * table indices into the internal representation of the bitfield.  It is
 * defined in ../h/i215g.h, and is not portable.
 *
 * Usage:
 *	I215MINOR(board, unit, drtab, partition),
*/
unsigned i215minor[] = {			/* [minor] device */
	i215MINOR(0,0,0,0),			/* [0+0] Wini format disk  */
	i215MINOR(0,0,0,1),			/* [0+1] Wini root part    */
	i215MINOR(0,0,0,2),			/* [0+2] Wini swap part    */
	i215MINOR(0,0,0,3),			/* [0+3] Wini usr  part    */
	i215MINOR(0,0,0,6),			/* [0+4] Wini error part   */
	i215MINOR(0,0,0,4),			/* [0+5] Wini whole disk   */
	i215MINOR(0,0,0,5),			/* [0+6] Wini MS-DOS part  */
	i215MINOR(0,4,0,0),			/* [0+7]  dnf0/dvf0 floppy */
	i215MINOR(0,4,1,1),			/* [0+8]  df0/f0 floppy    */
	i215MINOR(0,4,2,2),			/* [0+9]  syf0   floppy    */
	i215MINOR(0,4,3,3),			/* [0+10] dzf0/dxf0 floppy */
	i215MINOR(0,4,4,4),			/* [0+11] dvf0/df0 floppy  */
	i215MINOR(0,4,5,5),			/* [0+12] root   floppy    */
	i215MINOR(0,4,6,6),			/* [0+13] ram    floppy    */
	i215MINOR(4,8,0,0),			/* [0+14] tape reserved    */
	i215MINOR(4,8,1,0),			/* [0+15] tape reserved    */
	i215MINOR(0,8,0,0),			/* [0+16] smt0 st rewind   */
	i215MINOR(0,8,1,0),			/* [0+17] smnt0 st no-rew  */
	i215MINOR(4,0,0,0),			/* [0+18] Reserved         */
	i215MINOR(4,0,0,0),			/* [0+19] Reserved         */
};

/*
 *	Number of retries in case of soft error (configurable).
*/
int i215retry = 10;

/*
 * The following are static initialization variables
 * which are based on the configuration. These variables
 * MUST NOT CHANGE because the i215 device driver makes
 * most of the calculations based on these variables.
*/
#define	NUM215	((sizeof i215cfg) / (sizeof (struct i215cfg)))
int    N215 =   NUM215;			/* number of configured boards   */
struct iobuf    i215tab[NUM215];	/* buffer headers per board      */
struct iobuf    i215tbuf[NUM215];	/* I015 tape buffer headers per board */
struct buf      i215rbuf[NUM215];	/* raw buffer headers per board  */
struct i215dev *i215bdd[NUM215];	/* board-idx -> "dev" map        */
struct i215dev  i215dev[NUM215];	/* per-board data-structures     */
short  i215maxmin = ((sizeof i215minor)/(sizeof (struct i215minor)));
					/* maximum minor number posible. */
#define i215TMEM	8		/* number of external tape bufs	 */
int i215tbuf_max = i215TMEM;		/* maximum buffers allocated     */
struct i215tmem i215tmem[i215TMEM+1];	/* external buffer structures	 */
