/*
 * Copyright (C) 1985 Intel Corp.
 * 
 * INTEL CORPORATION PROPRIETARY INFORMATION
 * "@(#) c344 $State: XENIX_R3-5 $ $Date: 87/05/19 14:20:18 $";
 *
 * This software is supplied under the terms of a license agreement
 * or nondisclosure agreement with Intel Corporation and may not be
 * copied or disclosed except in accordance with the terms of that
 * agreement.
 */

/*
 * iSBX 344 BITBUS driver configuration.
 *
 *      The i344cfg structure contains 5 fields.  They are:
 *         1.   I/O address of the "DATA" register.
 *         2.   I/O address of the "COMMAND" register.
 *         3.   I/O address of the "STATUS" register.
 *         4.   PIC level of the RINT receive interrupt.
 *         5.   PIC level of the TINT transmit interrupt.
 *
 * 	There is no way to change these interrupt levels on the iSBC 286/10,
 *	because they are hardwired.
 *
 *      The interrupt levels chosen for the IBM PC AT are IRQ3 for RINT and
 *      IRQ5 for TINT.  These must be configured on the iPCX 344 as per the
 *      User's Guide.
 */

#include "../h/param.h"
#include "../h/i344.h"


struct i344cfg i344cfg = {
#ifdef PCAT
				0x208, 0x20A, 0x20C, 0x0B, 0x0D
#else
				0x80, 0x82, 0x84, 67, 68
#endif
			};

/*
 *   Definition of the size of the ring buffers.  
 *   This size should be even and should probably be a multiple of 512.
 */

#define	RING_SIZE	512
int	ring_size =	RING_SIZE;

