/*
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 *      "@(#) c534 $State: XENIX_R3-5 $ $Date: 86/05/30 13:24:02 $";
 */


/*
 * c534.c
 *	iSBC 534 Specific Configuration file.
 *
 * This split out from c.c to avoid name-clashing with other device-
 * specific configuration files.
 */

#include "../h/param.h"		/* this include types.h */
#include "../h/tty.h"
#include "../h/i534.h"


/*
 * N534 must be modified if the configuration
 * changes the number of isbc534 boards in the system.
 * Must also add addresses to the cfg structure below.
 *    I001	moved this here from i534.h to consolidate configuration
 *		options to the appropriate place.
 */
#define	NUM534		4	/* Number of isbc534's in configuration  */
int N534 = NUM534;	


/*
 * I001   moved these declarations to here from i534.c
 */
struct tty i534tty[NUM534*4];		/* 4 USARTs per 534 */
short i534addr[NUM534*4];               /* parallel to tty struct */
int	i534alive[NUM534];		/* does it live ?? */
int 	i534speed[NUM534*4];		/* current speed of tty */


/*
 * This table gives the board-base I/O address
 * for each possible iSBC 534 controller.  The driver procedure entry-
 * points are configured in c.c.
 * To reconfigure for a different number of 534's, you must add or
 * delete the appropriate addresses in the structure below.
 */

struct	i534cfg	i534cfg[NUM534] = {
		0x30,		/* first board base addr = 0x30 */
		0x40,
		0x50,
		0x60
};
