/*
 * Copyright (C) 1983 Intel Corp.
 */
/*
 * c544.c
 *	iSBC 544 Specific Configuration file.
 *      "@(#) c544 $State: XENIX_R3-5 $ $Date: 86/05/30 13:22:48 $";
 *
 * Thi stuff split out from c.c to avoid name-clashing with
 * other device-specific configuration files.
 */
#include "../h/param.h"
#include "../h/dir.h"	/* system directory structures */
#include "../h/user.h"	/* user structures (system)	*/
#include "../h/systm.h" /* system */
#include "../h/conf.h"	/* system configuration */
#include "../h/tty.h"	/* device structures (system)	*/
#include "../h/i8259.h"	/* some pic commands from system */
#include "../h/i544.h"
	
/*
 * To configure the maximum number of 544 boards in the system,
 * simply change NUM544. There is a maximum of 4 and a minimum of 1
 */
#define	NUM544	4
int	N544 = NUM544;

/*
 * The physical starting addresses of the i544 boards'
 * memory mapped I/O space.
 */
long	i544phys[] = {
		0x0FE0000,
		0x0FE4000,
		0x0FE8000,
		0x0FEC000
		};

/*
 * baud rate translation table
 */
int	i544baud[] = {
			0,	  0,	    0,  US_B110,	0,  US_B150,
			0,  US_B300,  US_B600, US_B1200,	0, US_B2400,
		 US_B4800, US_B9600, US_B19200, 	      0
		};

/*
 * per line tty state data used by Xenix
 * four tty structure entries per board
 */
struct	tty	  i544tty[NUM544*4];

/*
 * line and board state data for the iSBC 544
 * contains alive flag, physical address, selector,
 * copy of board's firmware board and line configuration
 * and control state.
 * one per configured board.
 */
struct	i544board i544board[NUM544];

/*
 * intermediate output buffers for block moves with poke
 * one 256 byte buffer per board
 */
char	i544o_buf[NUM544*TTYHOG];



