/*
 *         INTEL CORPORATION PROPRIETARY INFORMATION
 *
 *     This software is supplied under the terms of a license 
 *    agreement or nondisclosure agreement with Intel Corpo-
 *    ration and may not be copied or disclosed except in
 *    accordance with the terms of that agreement.
 */

/*
 * c8251.c
 *	8251 USART Specific Configuration file.
 *
 * history
 *	i000	br	11/10/86
 *		change NUM8251 and i8251cfg to make minor number
 *		1 be the real device (thus we can easily switch
 *		from 8274 to 8251 for the iapx386 case - still using
 *		the same minor number).
 *
 */

/*
 * "@(#) c8251 $State: XENIX_R3-5 $ $Date: 87/04/07 15:48:29 $";
 */

#include "../h/param.h"
#include "../h/tty.h"
#include "../h/i8251.h"



/*
 * N8251 must be modified if the configuration
 * changes the number of USARTS in the system.
 * Must also add addresses to the cfg structure below.
 */
#define	NUM8251		2	/* i000 */
ushort N8251 = NUM8251;	


/*
 * This table gives the board-base I/O address
 * for each possible iSBC 351 controller.  The driver procedure entry-
 * points are configured in c.c.
 * To reconfigure for a different number of 351's, you must add or
 * delete the appropriate addresses in the structure below.
 *
 *	NOTE:  this configuration is for the on-board 8251 on a 386/20.
 */

struct	i8251cfg i8251cfg[NUM8251] = {
		/* i000 start */
		/* minor - 0 - not used */
		0,		/* USART Data Port */
		0,		/* USART Control Port */
		0,		/* Timer Data Port */
		0,		/* Timer Control Port */
		0,		/* Input interrupt level */
		0,		/* Output interrupt level */
		0,		/* Timer number (on chip) */
		0,		/* Option specifications */
		/* i000 end */
		/* minor - 1 - this is the real one to use */
		0xD8,		/* USART Data Port */
		0xDA,		/* USART Control Port */
		0xD4,		/* Timer Data Port */
		0xD6,		/* Timer Control Port */
		0x46,		/* Input interrupt level */
		0x47,		/* Output interrupt level */
		2,		/* Timer number (on chip) */
		0,		/* Option specifications */
};

struct tty usrttty[NUM8251];
ushort	i8251alive[NUM8251];		/* does it live ?? */
ushort	i8251speed[NUM8251];		/* current speed of tty */


