/*
 * clp.c
 *	Line-printer specific configuration.
 *      "@(#) clp $State: XENIX_R3-5 $ $Date: 87/02/02 11:40:59 $";
 *
 * This split out from c.c to avoid name-clashing with other device-
 * specific configuration files.
 *
 *	i001	br	01/20/87
 *		add support for iSBX350 - 386/2x interface.
*/
#include "../h/types.h"
#include "../h/tty.h"
#include "../h/lp.h"

int lp_busy_delay =   LP_BDELAY;   /* timeout delay for printer busy */
int lp_daemon_delay = LP_DDELAY;   /* delay for polled wakeup see lp.h	*/
int lp_error_msg =    LP_MSG;	   /* LP_NO_MSG turns off error messages */
/*
 * This table gives the interrupt level and  I/O addresses
 * for each possible line-printer.  The driver procedure entry-
 * points are configured in c.c
*/

struct	lpcfg lpcfg = {
/*   Level, port A, port B, port C, Control */
	71,  0xc8,    0xca,   0xcc,    0xce
};

/*
 *	This table holds flags which allow a line discipline to be
 *	attached to the parallel port.
*/
struct tty lptty;
/* isbx_350 will automatically be set if a lp driver is
 * initialized on a 386/2x board
*/
int isbx_350 = 0;				/* i001 */
int lp_use_select = 1;				/* i001 */
int lp_daemon_lim = 120;		/* using lp_daemon_delay default
					 * provides about 2 minutes i001
					*/
