
/*
 * "@(#) conf $State: XENIX_R3-5 $ $Date: 86/11/13 17:03:04 $"
 */

/*
 *	@(#) h/conf.h 1.2 84/05/07 Copyright Microsoft Corporation, 1983
 *
 *	Copyright (C) Microsoft Corporation, 1983
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */
/*
 *	@(#) h/conf.h 1.2 84/05/07 Copyright Microsoft Corporation, 1983
 */




/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 */



/*
 * Declaration of block device switch. Each entry (row) is
 * the only link between the main unix code and the driver.
 * The initialization of the device switches is in the file conf.c.
 *
 * I001		4/3/85	rickb
 *	Added d_proc entry to block device interface
 *	to implement dynamic bad block handling, but
 *	general enough to use for other purposes.
 *
 * I002		5/1/86	jdh
 *	Added console device switch, so that kernel printf co
 *	is configurable.  needed for xenix 386.
 */
extern struct bdevsw
{
	int	(*d_open)();
	int	(*d_close)();
	int	(*d_strategy)();
	struct iobuf *d_tab;
	int	(*d_proc)();		/* I001 */
} bdevsw[];

/*
 * Character device switch.
 */
extern struct cdevsw
{
	int	(*d_open)();
	int	(*d_close)();
	int	(*d_read)();
	int	(*d_write)();
	int	(*d_ioctl)();
} cdevsw[];

int	bdevcnt;
int	cdevcnt;

/*
 * Console device switch		I002
 */
struct conssw {
	char	(*co)();
	int	co_dev;
};

extern struct conssw conssw;

/*
 * Line discipline switch.
 */
extern struct linesw
{
	int	(*l_open)();
	int	(*l_close)();
	int	(*l_read)();
	int	(*l_write)();
	int	(*l_ioctl)();
	int	(*l_input)();
	int	(*l_output)();
	int	(*l_mdmint)();
} linesw[];

int	linecnt;
