
/*
 * "@(#) ecc $State: XENIX_R3-5 $ $Date: 86/05/30 13:01:45 $"
 */

/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * INTEL 286/310 COMPUTER AND MAY REQUIRE MODIFICATION
 * WHEN ADAPTING XENIX TO NEW HARDWARE.
 */


/*
 * ECC support header file
 *
 * Defines various constants & structures for ecc support
 *
 * Written by Phil Barrett 12/17/82
 */
#define MAX_ECC 	0xFFF	/* maximum errors in a period */
#define NO_TYPE		0	/* no type of mem board */
/*
 * define ECC mode bits for iSBC 028CX, iSBC 056CX or
 *	iSBC 012CX
 */
#define	CX_TYPE			1	/* CX series type */
#define	CX_C_ERRORS		1	/* correct single bit errors */
#define	CX_NO_DIAG		2	/* dont go into diag mode */
#define	CX_CORRECT		4	/* enter correctdetect mode */
#define	CX_NO_EX_SYN		8	/* dont examine syndrome word */
#define	CX_ERROR_MASK		0x1F	/* mask for error status */
#define CX_HARD_ERROR		0x1F	/* multibit error */
#define CX_NO_ERROR		0x1E	/* no error occured */

/*
 * ecc table entry
 */
struct ecc {
		int	e_port;	/* I/O address of error stat register */
		int	e_type;	/* memory board type */
		int	e_count;/* count of correctable errors */
		int	(*e_eproc)();	/* procedure to handle error */
		int	(*e_iproc)();	/* procedure to init ecc */
		};

/*
 * e_eproc and e_iproc are called with the following interface:
 *	e_eproc( ecc, bd )
 *	struct ecc *ecc;
 *
 *	e_iproc( ecc );
 *	struct ecc *ecc;
 */
