
/*
 * "@(#) i8274 $State: XENIX_R3-5 $ $Date: 86/05/30 13:09:25 $"
 */

/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */

/* i8274.h */



#define	M_REG0	0x00		/* select reg 0 */
#define	M_REG1	0x01		/* select reg 1 */
#define	M_REG2	0x02		/* select reg 2 */
#define	M_REG3	0x03		/* select reg 3 */
#define	M_REG4	0x04		/* select reg 4 */
#define	M_REG5	0x05		/* select reg 5 */
#define	M_REG6	0x06		/* select reg 6 */
#define	M_REG7	0x07		/* select reg 7 */

#define	M_RS_EX_INT	0x10		/* reset external ints	wr0 */
#define	M_CHAN_RES	0x18		/* channel reset	wr0 */
#define	M_RS_TX_INT	0x28		/* reset external ints	wr0 */
#define	M_ERR_RES	0x30		/* error reset		wr0 */
#define	M_EOI		0x38		/* reset internal ints 	wr0 */
#define	M_INT_EN	0x01		/* enable ints		wr1 */
#define	M_TX_INT_EN	0x02		/* Tx int enable 	wr1 */
#define	M_RX_INT	0x18		/* interrupt on all chars wr1 */
#define M_SAV		0x04		/* status affects vector wr1 */
#define M_INT_PRIO	0x04		/* interrupt prio level	wr2a */
#define	M_RX_EN		0x01		/* enable Rx		wr3 */
#define	M_RX_8BPC	0xC0		/* Rx 8 bits/char	wr3 */
#define	M_RX_7BPC	0x40		/* Rx 7 bits/char	wr3 */
#define	M_RX_6BPC	0x80		/* Rx 6 bits/char	wr3 */
#define	M_16X		0x40		/* 16x clock rate	wr4 */
#define	M_1STOP		0x04		/* one stop bit		wr4 */
#define	M_2STOP		0x06		/* two stop bits	wr4 */
#define	M_PAR_EN	0x01		/* parity enable	wr4 */
#define	M_PAR_EVEN	0x02		/* even parity, else odd wr4 */
#define	M_RTS		0x02		/* request to send	wr5 */
#define	M_TX_EN		0x08		/* Tx enable		wr5 */
#define	M_BREAK		0x10		/* send break 		wr5 */
#define	M_TX_8BPC	0x60		/* Tx 8 bits/char	wr5 */
#define	M_DTR		0x80		/* data terminal ready	wr5 */
#define	M_CHAR_AV	0x01		/* recieve char avail rr0 */
#define	M_TX_EMPTY	0x04		/* Tx buffer empty rr0 */
#define	M_PERROR	0x10		/* parity error		rr1 */
#define	M_FRERROR	0x20		/* framing error	rr1 */
#define	M_OVERRUN	0x40		/* overrun error	rr1 */
#define	M_CHA		0x10		/* channel A bit (unshifted) rr2 */

#define CH_A		0		/* index into i74cfg table for chan A */
#define CH_B		1		/* index into i74cfg table for chan B */

/*
 * data structures for 8274
 * The mpsc (managed by the i8274 driver) is described in a table
 * of i74cfg structures. 
 */
struct i74cfg {
	unsigned	m_ctrl;	/* control port for this channel */
	unsigned	m_data;	/* data port for this channel */
	unsigned	m_tctrl;/* timer control port */
	unsigned	m_tdata;/* timer data port */
	unsigned	m_tnum; /* timer number */
	unsigned	m_intlev;/* interrupt level */
	};

/*
 * baud rate definitions for 286/10
 */
#define	i74_B19200	4
#define	i74_B9600	8
#define	i74_B4800	16
#define	i74_B2400	32
#define i74_B1800	43
#define	i74_B1200	64
#define	i74_B600	128
#define	i74_B300	256
#define i74_B200	384
#define	i74_B150	512
#define i74_B134	571
#define	i74_B110	698
#define	i74_B75		1024
#define i74_B50		1536
#define i74_B0		0
#define	ISPEED		13	/* 9600 baud */

#define	MINORMSK	0x1F
#define	MODEMMSK	0x20

#define	RATEMD0		0x36

#define	TEST_VECT	0xA5
#define	VECT_MASK	0xE0
#define	INT_PENDING	0x02
