
/*
 * "@(#) param $State: XENIX_R3-5 $ $Date: 86/05/30 13:04:54 $"
 */

/*
 *	@(#) h/param.h 1.11 84/05/07 Copyright Microsoft Corporation, 1983
 *
 *	Copyright (C) Microsoft Corporation, 1983
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * INTEL 80286 CPU AND MAY REQUIRE MODIFICATION
 * WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

/* Modification History:
 * 	I000	rajiv	22 Jan 1985
 *		- itocg macro changed to handle last inode correctly.
 *		  remember inodes start from 1.
 *	I001	llk	4/16/85
 *		- moved idt out of kernel data space
 *	I002	rajiv	4/26/85
 *		- newline discipline routines.
 *	I003	CLQ	6/22/85
 *		- removed define for CDLIMIT and added to space.h
 *		  so ulimit can be defined and changed in /sys/conf/master.
 *	I004	CLQ	7/15/85
 *		- changed CBUFSZ to be 257 instead of 256 as at 256 the line
 *		  could be hung by a test in tt0 not happening.
 *	I005	dilip	5/30/85
 *		- Added MAXSYMLINK definition (merged from an earlier param.h)
 *	I006	WDS	10/22/85
 *		- Added KHCOUNT for Kernel Histogram
 */

/*
 * Adjustable parameters
 */
#define	SSIZE	4096		/* initial stack size (bytes) */
#define	SINCR	1024		/* increment of stack (bytes) (not used)*/
#define	NOFILE	20		/* max open files per process */
#define	CANBSIZ	256		/* max size of typewriter line */
#define	HZ	50		/* Ticks/second of the clock */
#define	MSGBUFS	128		/* Characters saved from error messages */
#define	NCARGS	5120		/* # characters in exec arglist */
#define	CBUFSZ	257		/* Size of tty ring buffer. I002 I004 */
#define	MAXTTYS	16		/* Max # open ttys */
#define	NIOSTAT	50		/* max number of bufs to keep stats for */
#define	MAXPID	30000		/* max process id */
#define	MAXUID	60000		/* max user id */
#define	MAXLINK	1000		/* max links */
#define	MAXSYMLINK 8		/* max symlink expansions per namei I005 */
/***** I003 START *****
 *#define	CDLIMIT	(1L<<13)	   default max write address 
 ***** I003 END   *****
 */

#define KHCOUNT	8		/* Kernel Histogram count - I006 */

#define MINBUF	40		/* minimum # of buffers */
#define	EXPBUFSEL 7		/* No of selectors reserved for exported bufs */
#define KSSIZE	1024		/* kernel stack size */
#define NUSEGS	154		/* maximum # of user segments per process */
#define SELSZ   8		/* sizeof(struct desctab) */
#define LDTSZ   NUSEGS * SELSZ  /* size (in bytes) of a process's ldt */
#define OFFUSRPG 0		/* address of U page (for fpsup.s) */
/*
 *  TEMPORARY
 */  
#define	USIZE	7		/* setup U page of 2k assuming 1/2k pages */
/*#define	USIZE	(btoms((long)sizeof(struct user))) /* size of U page */

/*
 * priorities
 * probably should not be
 * altered too much
 */

#define	PSWP	0
#define	PINOD	10
#define	PRIBIO	20
#define	PZERO	25
#define	NZERO	20
#define	PPIPE	26
#define	PWAIT	30
#define	PSLEP	40
#define	PUSER	50
#define	PIDLE	127

/*
 * signals
 * dont change
 */

#define	NSIG	20
/*
 * No more than 32 signals (1-32) because they are
 * stored in bits in a long.
 */
#define	SIGHUP	1	/* hangup */
#define	SIGINT	2	/* interrupt (rubout) */
#define	SIGQUIT	3	/* quit (FS) */
#define	SIGILL	4	/* illegal instruction */
#define	SIGTRAP	5	/* trace or breakpoint */
#define	SIGIOT	6	/* iot */
#define	SIGEMT	7	/* emt */
#define	SIGFPE	8	/* floating exception */
#define	SIGKILL	9	/* kill, uncatchable termination */
#define	SIGBUS	10	/* bus error */
#define	SIGSEGV	11	/* segmentation violation */
#define	SIGSYS	12	/* bad system call */
#define	SIGPIPE	13	/* end of pipe */
#define	SIGALRM	14	/* alarm clock */
#define	SIGTERM	15	/* Catchable termination */
#define	SIGUSR1	16	/* user defined signal 1 */
#define	SIGUSR2	17	/* user defined signal 2 */
#define	SIGCLD	18	/* child death */
#define	SIGPWR	19	/* power-fail restart */

#define	FSIG_DFL	((faddr_t) 0)
#define	FSIG_IGN	((faddr_t) 1)

/*
 * fundamental constants of the implementation--
 * cannot be changed easily
 */

#define	NBPW	sizeof(int)	/* number of bytes in an integer */
	/*
	 *      *** WARNING ***
	 * Some io devices may have a problem 
	 * if BSIZE is greater than MMPGSZ	
	 * If BSIZE changes, so must NSBFILL, BSHIFT,
	 * NSHIFT, LINOPB
	 * I001  If BSIZE > 1024, code to move idt out of kernel data space 
	 * will break.
         */
#define	BSIZE	1024		/* size of secondary block (bytes) */
#define	BSHIFT	10		/* LOG2(BSIZE) */
#define	BMASK	(BSIZE - 1)	/* BSIZE-1 */
#define	BSLOP	0		/* must be 0 for current copyio implemtation*/
#define	NINDIR	(BSIZE/sizeof(daddr_t))
#define	NSHIFT	8		/* LOG2(NINDIR) */
#define	NMASK	(NINDIR - 1)	/* NINDIR-1 */
#define	INOPB	(BSIZE/sizeof(struct dinode))	/* # inodes per block */
#define	LINOPB	4		/* LOG2(INOPB) */
#define	NULL	0
#define	NODEV	(dev_t)(-1)
#define	ROOTINO	((ino_t)2)	/* i number of all roots */
#define BBINO	((ino_t)1)	/* i number of bad-block inode */
#define	SUPERB	((daddr_t)1)	/* block number of the super block */
#define	DIRSIZ	14		/* max characters per directory */
#define	NICINOD	100		/* number of superblock inodes */
#define	NICFREE	100		/* number of superblock free blocks */
#define	NSBFILL	370		/* aligns s_magic & s_type at end of SB blk */

/*
 * MMU parameters.
 */

#define	MMPGSZ	512		/* bytes/page in the MMU */
#define	LMMPGSZ	9		/* log2(MMPGSZ) */
#define NPAGEPS	128		/* 64k/MMPGSZ = number of pages per segment */
#define MAXPAGES  32768L

/*
 * Some macros for units conversion
 */

extern int kmemstart;	/* set to KMEMSTART - defined by oem in machdep.h */

/*
 * mem size to disk blocks and disk blocks to mem size.
 *	Assumes BSIZE and MMPGSZ are both powers of 2.
 */
/* #if BSIZE > MMPGSZ */
#define 	mstod(x)	( ((x) + ((BSIZE/MMPGSZ)-1)) / (BSIZE/MMPGSZ))
#define 	dtoms(x)	((x)*(BSIZE/MMPGSZ))
/* #else 
 * #define	mstod(x)	((x)*(MMPGSZ/BSIZE))
 * #define 	dtoms(x)	( ((x) + ((MMPGSZ/BSIZE)-1)) / (MMPGSZ/BSIZE))
 * #endif
 */

/* inumber to disk address */
/****************************************************************
#define	itod(x)	(daddr_t)(((unsigned)(x)+(INOPB+INOPB-1))>>LINOPB)
****************************************************************/

/* inumber to disk offset */
#define	itoo(x)	(int)(((x)+(INOPB+INOPB-1))&(INOPB-1))


/* Added definitions of itocg and dtocg */

/*
 * inode to cylinder group macro
 * I000
 */
#define itocg(ino,fp)	( (ino-1) / (fp)->fs_cginodes )

/*
 * data block to cylinder group macro
 */
#define dtocg(d,fp)	( ((d)-2) / (fp)->fs_cgblocks)

/* mem size to bytes */
#define	mstob(x)	((x)<<LMMPGSZ)

/* bytes to mem size */
#define	btoms(x)      ((unsigned) (((long)(x) + (MMPGSZ-1)) >> LMMPGSZ))

/* address (long (32 bit)) to page number (int)*/
#define	atomlt(x)	((int)(((paddr_t)(x))>>LMMPGSZ))

/* address (long (32 bit)) to page count (int)*/
#define	atoml(x)	((int)(((paddr_t)(x)+(MMPGSZ-1))>>LMMPGSZ))

/* address (long (32 bit)) to offset (int) get bits LMMPGSZ-1 - 0 */
#define	atoo(x)		((int)((x)&(MMPGSZ-1)))

/* far pointer (faddr_t) to segment (int) (get high 16 bits of faddr_t) */
#define	ftoseg(x)		((unsigned) ((long) (x) >> 16))

/* far pointer (faddr_t) to offset (int) (get low 16 bits of faddr_t) */
#define	ftooff(x)		((unsigned) (x))

/* seg off to far pointer (faddr_t) */
#define sotofar(seg, off) \
	(((faddr_t) (((long)(unsigned) (seg)) << 16)) + (unsigned) (off))

/* when sotofar() is used to set up an (faddr_t) parameter to a function call */
#define FADDR(seg, off)		off, seg

/* Memory location to logical address */
#define mltoa(x) ((paddr_t) (x) << LMMPGSZ)

/* High word of a long */
#define HIGHWORD(x)	((int)((long)x >> 16))

/* low word of a long */
#define LOWWORD(x)	((int)x)

/* physical to kernel logical */
#define ptok(x) ((caddr_t)(x-kmemstart))

/* kernel logical to physical */
#define ktop(x) ((paddr_t)((long)x+kmemstart))

#include	"types.h"

/*
 * Machine-dependent bits and macros
 */

#define SPL0MASK        0x00            
#define USERMODE(ps)	((ps)&PS_USER)
#define CLKONLY(ps)     (((ps)&PS_PRIMASK)==(maxmask<<8))

#define	DATASTART(ts,sep)	((caddr_t) 0)	/* start of user data */
#define	STACKSTART(ss)		((caddr_t) 0)	/* start of user stack */
						/* base address of user stack */
#define	USRSTACK	u.u_stkbot
#define	URSBC		0		/* User stk Reg Save area Byte Cnt */
#define SHWDSZ          (sizeof(int)+6) /* space on user stack for shell word */

/*
 * 286 simulated "state" definitions.
 */

#define	PS_USER		0x01		/* "user" mode */
#define	PS_PRIMASK	0xFF00		/* last priority (PIC mask) was spl6 */

/* Conditional compilation */
#define	PAGEMMU				/* mmu is divided in pages */
#define	SHORTINT			/* sizeof(int)==sizeof(short) */
/*#define	BYTESWAP*/		/* byte ordering is opposite that of pdp11
/*#define       OLDFORK*/               /* return to parent by bumping pc by 2 */
#define       FIXEDSTACK                /* stack cannot grow */
#define       BUFMAPOUT                 /* buffers are mapped out */
/*#define LARGECODE*/                   /* kernel supports multisegment code */
