
/*
 * "@(#) space $State: XENIX_R3-5 $ $Date: 86/05/30 13:05:59 $"
 */

/*
 *	@(#) h/space.h 1.4 84/05/07 Copyright Microsoft Corporation, 1983
 *
 *	Copyright (C) Microsoft Corporation, 1983
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * INTEL 80286 CPU AND MAY REQUIRE MODIFICATION
 * WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

/*
 * Modification History
 *
 *	I000	llk	4/16/85
 *		mods for moving idt out of kernel data space
 *
 *	I001	llk	6/21/85
 *		variable declared for auxhooks to work.
 *
 *	I002	CLQ	6/22/85
 *		added variable for ulimit setting from master.
 *	I003	dilip	10/7/85
 *		user/suser creation of symbolic links is configurable
 *
 *	I004	rinne	10/3/85
 *		added conditional to only declare one byte of 
 *		space for sabuf if NSABUF <= 2.  The byte is
 *		necessary to resolve references from other
 *		routines.  Further, a minimum of two sabufs is
 *		inforced by conditional compilation, ref. comments
 *		below.
 *	I005	jdm	10/14/85
 *		Added num_drv_sel (set from NDRSEL)
 *		configure the number of driver selectors in the
 *		kernel without recompilation of the kernel.
 *
 *	I006    WDS     10/22/85
 *		Added khisto variable to allow for configurable 
 *		Kernel histogram.
 */

#include  "buf.h"
#include  "tty.h"
#include  "proc.h"
#include  "text.h"
#include  "dir.h"
#include  "a.out.h"
#include  "user.h"
#include  "file.h"
#include  "inode.h"
#include  "map.h"
#include  "callo.h"
#include  "mount.h"
#include  "var.h"
#include  "utsname.h"
#include  "sysinfo.h"
#include  "locking.h"
#include  "sd.h"

int Timezone=TIMEZONE;
int Dstflag=DSTFLAG;
int Cmask=CMASK;
int nfs1=0;
int nfs2=0;
int do_nfc;
int ttys=MAXCBUFS;
int naux=0;
long ulimcfg=ULIMITCFG; /* I002 */
int sl_root=SLROOT;	/* I003 */
int khisto = 0;		/* I006 */
#if NSABUF<=2
/* I004
 *	The space for two io buffers is already researved in the kernel
 * by moving the idt declaration out of the kernel data segment at boot
 * time.  if the user requests less than two, the system may as well get
 * the two since the space is already researved.
 */
char sabuf[1][1];		/* I004 */
#undef NSABUF
#define NSABUF	2
#else
char sabuf[NSABUF-2][BSIZE];	/* I000 */
#endif

#if NBUF==0
struct buf buf[MAXBUF+NSABUF];
#else
struct buf buf[NBUF+NSABUF];
#endif
struct	hbuf	hbuf[NHBUF];	/* buffer hash table */
struct file file[NFILE];
struct inode inode[NINODE];
struct locklist locklist[NFLOCKS];
struct sd sdtab[NSDSEGS];
struct proc proc[NPROC];
struct text text[NTEXT];
struct map coremap[CMAPSIZ];
struct map swapmap[SMAPSIZ];
struct callo callout[NCALL];
struct mount mount[NMOUNT];
struct sysinfo sysinfo;
struct syswait syswait;
int Hz=HZ;

struct var v=
{
	NBUF,
	NSABUF,
	NHBUF,
	NHBUF-1,
	MAXBUF,
	NCALL,
	NINODE,
	&inode[NINODE],
	NFILE,
	&file[NFILE],
	NMOUNT,
	&mount[NMOUNT],
	NPROC,
	&proc[NPROC],
	NTEXT,
	&text[NTEXT],
	0,
	MAXUPRC,
	MAXMEM,
	NFLOCKS,
	NSDSEGS,
};

int	num_drv_sel=NDRSEL;		/* I005 */
