
/*
 * "@(#) pwd $State: XENIX_R3-5 $ $Date: 86/05/30 13:53:14 $"
 */

/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	Copyright (C) Microsoft Corporation, 1983
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */
/***	pwd.h
 *
 *	MODIFICATION HISTORY
 *	M000	14 Apr 83	andyp
 *	- 3.0 upgrade.  (uncommented).  3.0 source picked up, unchanged.
 *	  Added comments.
 */

struct passwd {	/* see getpwent(3) */
	char	*pw_name;	/* login name */
	char	*pw_passwd;	/* encrypted password */
	int	pw_uid;		/* numerical user ID */
	int	pw_gid;		/* numerical group ID */
	char	*pw_age;	/* data for password aging, see below */
	char	*pw_comment;
	char	*pw_gecos;
	char	*pw_dir;	/* initial working directory */
	char	*pw_shell;	/* program to use as shell */
};

/*
 *	Characters for pw_passwd and 'digits' for pw_age taken from
 *	the 64 character alphabet (., /, 0-9, a-z, A-Z).
 *
 * pw_age field:
 *	Mmc...c
 *	M	= maximum number of weeks for which password is valid.
 *	m	= minimum period in weeks which must expire before
 *		  password may be changed.
 *	c...c	= week (counted from 'the epoch') when password was last
 *		  changed.
 */
