
/*
 * "@(#) exttab $State: XENIX_R3-5 $ $Date: 86/05/30 13:02:05 $"
 */

/* CAUTION:
 * This file contains storage declarations for tables needed by
 * extent allcation routines.
 * It SHOULD NOT be included more than once in any program.
 *
 */
#define	EXTTABSIZE	4	/* size of 1 extant table below */

/*
 *  The extsizetab table contains two tables.  Extsizetab[0] thru
 *  extsizetab[3] contains the extent low water marks, high water marks 
 *  and division factor for a cylinder group that is filling up.  
 *  Extsizetab[4] thru extsizetab[7] tcontains the extent low water marks, 
 *  high water marks and division factor for a cylinder group that is 
 *  being emptied.  The two tables overlap each other to prevent a cylinder 
 *  group from ocillating on a boundary.
 */
struct	extsizetab	extsizetab[]={  30 , 100 ,  1 ,
					20 ,  29 ,  2 ,
					10 ,  19 ,  4 ,
					 0 ,   9 , 32 ,
					35 , 100 ,  1 ,
					25,   34 ,  2 ,
					15,   24,   4 ,
					 0,   14,  32 
				      };

/* mask[i] gives you mask with 1's  starting at i'th position in
 * the byte
 */

char	mask[] = { 0xFF, 0x7F, 0x3F, 0x1F, 0x0F, 0x07, 0x03, 0x01};

/* mask1[i] gives you mask with 1 in ith position in the byte
*/
char	mask1[]= { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};

/* char	efc[256]; */	/* count of free blocks at end of byte */
/* char	bfc[256]; */	/* count of free blocks at start of byte */
/* char	maxc[256]; */	/* count of maximum free blocks in byte */


char	bfc[] = {
0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  
0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  
0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  
0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  
0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  
0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  
0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  
0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  
0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  
0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x0,  0x1,  0x1,  
0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  
0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  
0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  
0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  
0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x2,  0x2,  0x2,  
0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  
0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  
0x2,  0x2,  0x2,  0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  
0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  0x4,  0x4,  0x4,  0x4,  0x4,  0x4,  0x4,  
0x4,  0x5,  0x5,  0x5,  0x5,  0x6,  0x6,  0x7,  0x8};


char	efc[]={
0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x3,  0x0,  0x1,  0x0,  0x2,  0x0,  
0x1,  0x0,  0x4,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x3,  0x0,  0x1,  
0x0,  0x2,  0x0,  0x1,  0x0,  0x5,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  
0x3,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x4,  0x0,  0x1,  0x0,  0x2,  
0x0,  0x1,  0x0,  0x3,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x6,  0x0,  
0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x3,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  
0x0,  0x4,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x3,  0x0,  0x1,  0x0,  
0x2,  0x0,  0x1,  0x0,  0x5,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x3,  
0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x4,  0x0,  0x1,  0x0,  0x2,  0x0,  
0x1,  0x0,  0x3,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x7,  0x0,  0x1,  
0x0,  0x2,  0x0,  0x1,  0x0,  0x3,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  
0x4,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x3,  0x0,  0x1,  0x0,  0x2,  
0x0,  0x1,  0x0,  0x5,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x3,  0x0,  
0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x4,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  
0x0,  0x3,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x6,  0x0,  0x1,  0x0,  
0x2,  0x0,  0x1,  0x0,  0x3,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x4,  
0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x3,  0x0,  0x1,  0x0,  0x2,  0x0,  
0x1,  0x0,  0x5,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x3,  0x0,  0x1,  
0x0,  0x2,  0x0,  0x1,  0x0,  0x4,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  
0x3,  0x0,  0x1,  0x0,  0x2,  0x0,  0x1,  0x0,  0x8};


char	maxc[]={
0x0,  0x1,  0x1,  0x2,  0x1,  0x1,  0x2,  0x3,  0x1,  0x1,  0x1,  0x2,  0x2,  
0x2,  0x3,  0x4,  0x1,  0x1,  0x1,  0x2,  0x1,  0x1,  0x2,  0x3,  0x2,  0x2,  
0x2,  0x2,  0x3,  0x3,  0x4,  0x5,  0x1,  0x1,  0x1,  0x2,  0x1,  0x1,  0x2,  
0x3,  0x1,  0x1,  0x1,  0x2,  0x2,  0x2,  0x3,  0x4,  0x2,  0x2,  0x2,  0x2,  
0x2,  0x2,  0x2,  0x3,  0x3,  0x3,  0x3,  0x3,  0x4,  0x4,  0x5,  0x6,  0x1,  
0x1,  0x1,  0x2,  0x1,  0x1,  0x2,  0x3,  0x1,  0x1,  0x1,  0x2,  0x2,  0x2,  
0x3,  0x4,  0x1,  0x1,  0x1,  0x2,  0x1,  0x1,  0x2,  0x3,  0x2,  0x2,  0x2,  
0x2,  0x3,  0x3,  0x4,  0x5,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x3,  
0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x3,  0x4,  0x3,  0x3,  0x3,  0x3,  0x3,  
0x3,  0x3,  0x3,  0x4,  0x4,  0x4,  0x4,  0x5,  0x5,  0x6,  0x7,  0x1,  0x1,  
0x1,  0x2,  0x1,  0x1,  0x2,  0x3,  0x1,  0x1,  0x1,  0x2,  0x2,  0x2,  0x3,  
0x4,  0x1,  0x1,  0x1,  0x2,  0x1,  0x1,  0x2,  0x3,  0x2,  0x2,  0x2,  0x2,  
0x3,  0x3,  0x4,  0x5,  0x1,  0x1,  0x1,  0x2,  0x1,  0x1,  0x2,  0x3,  0x1,  
0x1,  0x1,  0x2,  0x2,  0x2,  0x3,  0x4,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  
0x2,  0x3,  0x3,  0x3,  0x3,  0x3,  0x4,  0x4,  0x5,  0x6,  0x2,  0x2,  0x2,  
0x2,  0x2,  0x2,  0x2,  0x3,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x3,  0x4,  
0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x2,  0x3,  0x2,  0x2,  0x2,  0x2,  0x3,  
0x3,  0x4,  0x5,  0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  0x3,  
0x3,  0x3,  0x3,  0x3,  0x3,  0x4,  0x4,  0x4,  0x4,  0x4,  0x4,  0x4,  0x4,  
0x4,  0x5,  0x5,  0x5,  0x5,  0x6,  0x6,  0x7,  0x8};


