
/*
 * "@(#) format $State: XENIX_R3-5 $ $Date: 86/05/30 13:02:47 $"
 */


/*
 *	INTEL CORPORATION PROPIETARY INFORMATION
 *
 *	This software is supplied under the terms
 *	of a license agreement or nondisclosure
 *	agreement with Intel Corporation and may
 *	not be copied nor disclosed except in
 *	accordance with the terms of that agreement.
 */

/**********************************************************************
 *
 * TITLE:	Includes For Intel Format
 *
 * DATE:	August 1, 1985
 *
 * AUTHOR:	Richard N. Bryant
 *
 * SUMMARY:
 *	Defines the interface for formatting
 *	ioctl calls to Intel block device drivers.
 *
 **********************************************************************/


/*
 * ioctl format command structure.
 * data passed by user process.
 */
struct format {
	int	f_track;		/* track, partition relative */
	int 	f_intl;			/* interleave factor */
	int 	f_skew;			/* skew factor, not used */
	char 	f_type;			/* format type code */
	char 	f_pattern[4];		/* data block pattern */
};

#define	f_sector	f_pattern[0]
#define f_pat		f_pattern
#define f_interleave	f_intl

/*
 * ioctl command(s)
 */
#define	TRK_FORMAT	(('W'<<8)|0)	/* format drive track ioctl command */
#define	DRV_STAT	(('W'<<8)|1)	/* get drive status ioctl command */

/*
 * format type codes
 */
#define	FORMAT_DATA	 0x00		/* format as data track */
#define	FORMAT_READ	 0x01		/* read data track sector headers */
#define	FORMAT_ALTERNATE 0x40		/* format as alternate track */
#define	FORMAT_BAD	 0x80		/* format as bad track */


