
/*
 * "@(#) sysinfo $State: XENIX_R3-5 $ $Date: 86/05/30 13:06:19 $"
 */

/*
 *	@(#) h/sysinfo.h 1.2 84/05/07 Copyright Microsoft Corporation, 1983
 *
 *	Copyright (C) Microsoft Corporation, 1983
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */
/*
 *	@(#) h/sysinfo.h 1.2 84/05/07 Copyright Microsoft Corporation, 1983
 */



/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 *
 *  I001 - wds May 23, 1984
 *	Documented sysinfo structure.  Add dhisto and ttystat variables.
 */

struct sysinfo {
	time_t	cpu[3];  /*  Clock ticks				*/
#define	CPU_IDLE	0
#define	CPU_USER	1
#define	CPU_KERNEL	2
	time_t	wait[3];/*  If CPU was idle then why was it waiting	*/
#define	W_IO	0
#define	W_SWAP	1
#define	W_PIO	2
	long	bread;  /*  Number of disk accesses for read requests	*/
	long	bwrite; /*  Number of disk accesses for write requests	*/
	long	lread;  /*  Total number of read request		*/
	long	lwrite; /*  Number of write requests including delayed	*/
	long	swapin;
	long	swapout;
	long	pswitch;/*  Number of times scheduler was called	*/
	long	qswitch;/*  Number of times processes placed on run Q	*/
	long	idle;   /*  Number of times the Kernel called idle()	*/
	long	preempt;
	long	syscall;
	long	iget;   /*  Number of inode references			*/
	long	namei;  /*  Number of pathname conversions to inodes	*/
	long	dirblk; /*  Number of directoreis accessed		*/
	long	readch; /*  Number of bytes uer read from disk		*/
	long	writech;/*  Number of bytes user wrote to the disk	*/
	long	rcvint;
	long	xmtint;
	long	mdmint;
	long	rawch;  /*  Number of raw input characters		*/
	long	canch;  /*  Number of conacal input characters		*/
	long	outch;  /*  Number of output characters			*/
/*
 *  Intel extensions
 */
	long	kalloc; /*  Number of times kernel buf flushed 		*/
	long	talloc; /*  Total number of buffers allocated	    	*/
	long	uread;  /*  Number of disk accesses to read user data	*/
	long	ulread; /*  Total number of user read requests		*/
	long	ulwrite;/*  Total of user write requests		*/
	ushort	dcount;	/*  Disk device histogram array index		*/
	dev_t	dmajor;	/*  Disk device number dhisto is histogramming	*/
	long	daccess;/*  Number of disk accesses to kernel data	*/
	time_t	tstamp; /*  Time stamp for computing rates		*/
};
extern struct sysinfo sysinfo;

struct syswait {
	short	iowait;
	short	swap;
	short	physio;
};
extern struct syswait syswait;

#ifdef TTYSTAT
/*
 *  Definitions and data structures for ttystats program
 */
#define	TTYSTSZ	24
#define TTYXLSZ	21

struct ttystat {
	short	cooked;		/*  Terminal's mode:  raw or cooked	*/
	int	i_cc;		/*  Number of characters in input clist	*/
	int	o_cc;		/*  Number of characters in output clist*/
	long	inchar;		/*  Number of characters input		*/
	long	outchar;	/*  Number of characters output		*/
	time_t	stime;		/*  Starting time for raw or cooked mode*/
	time_t	rawtime;	/*  Amount of time spent in raw mode	*/
	time_t	cooktime;	/*  Amount of time spent in cooked mode	*/
	time_t	opentime;	/*  Time since device has been opened	*/
};

extern	struct ttystat ttystats[TTYSTSZ];
extern	int	ttystx;
extern	int	ttyxlat[TTYXLSZ];

#endif
