
/*
 * "@(#) usart $State: XENIX_R3-5 $ $Date: 86/05/30 13:08:36 $"
 */

/*
 *	@(#) io/usart.h 1.1 84/05/07 Copyright Microsoft Corporation, 1983
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */

/*
 * THIS FILE CONTAINS CODE SPECIFIC TO THE INTEL 86/330
 * COMPUTER. IT MAY REQUIRE MODIFICATION WHEN MOVING
 * XENIX TO DIFFERENT MACHINE ARCHITECTURES OR CONFIGURATIONS.
 */



/*
 * usart.h
 *	Misc definitions for 86/12A on-board USART.
 *
 * Bob Beck, 12-15-81.
 */

/*
 * Port Addresses for:
 * 	SERIAL	8251A
 * 	PIT	8253
 */

#define SER_DATA_PORT        0xD8
#define SER_CONTROL_PORT     0xDA

/*
 * Control commands for 8251A
 *
 * SER_RESET commands resets the 8251A
 *
 * SER_MODE command sets the 8251A for:
 * 	16X clock
 * 	8 bits
 * 	No parity
 * 	2 stop bits
 *
 * SER_CMD command sets the 8251A for:
 * 	Transmit enable
 * 	DTR on
 * 	Receive enable
 * 	Error reset
 * 	RTS on
 */

#define SER_RESET            0x40
#define SER_MODE             0xCE
#define SER_CMD              0x37

/*
 * Definition of ready bits for 8251A
 */

#define SER_RX_READY         0x02
#define SER_TX_READY         0x01

/*
 * Baud rate selection.  These go into the clock counter.
 */

#define	US_B38400	2
#define	US_B19200	4
#define	US_B9600	8
#define	US_B4800	16
#define	US_B2400	32
#define US_B1800	48
#define	US_B1200	64
#define	US_B600		128
#define	US_B300		256
#define US_B200		384
#define	US_B150		512
#define	US_B110		698
#define	US_B75		1024
#define US_B50		1536
#define US_B0		0
