# Copyright Intel Corp. 1985,1986
# Author:  Colin Hulme 4-26-86
#
# Modified:  Colin Hulme 5-5-86
#            To add WPART entries as a hook for future fsck handling
# scp311.ss_version[] ="@(#) scp311.ss $State: XENIX_R3-5_U2 $ $Date: 88/02/19 14:32:43 $";
#

echo "`date` started extra wini configuration" >> $ZAPLOG
wini0=`grep "^WINI0" $CFPROPOSED`

#################### check if user currently has configuration ##########
if [ -f $SWITCHFLAG -o $INITIAL != Y ] ; then
############### get wini configuration information $CFPROPOSED ############
    wini_count=0
    i=1
    temp=\^WINI$i
    while grep "$temp" $CFPROPOSED >/dev/null ;
	do
	temp1=`grep "$temp" $CFPROPOSED`
	eval wini$i=\"$temp1\"
	wini_count=`expr $wini_count + 1`
	i=`expr $i + 1`
	temp=\^WINI$i
    done
############### get tape configuration information $CFPROPOSED ############
    tape_count=0
    i=0
    temp=\^TAPE$i
    while grep "$temp" $CFPROPOSED >/dev/null ;
	do
	temp1=`grep "$temp" $CFPROPOSED`
	eval tape$i=\"$temp1\"
	tape_count=`expr $tape_count + 1`
	i=`expr $i + 1`
	temp=\^TAPE$i
    done
################ Show user current configuration #####################
    ORIGIFS=$IFS
    IFS=,
    clear
    echo "You have specified the following peripheral configuration:\n"
    echo -n "        System Wini 0 -     "
    echo $wini0 | awk '{printf $6 " " $7 " " $8 "\n"}'
    i=1
    while test $i -le $wini_count
	do
	echo -n "        Additional Wini $i - "
	temp="\$wini$i"
	eval echo $temp|awk '{printf $6 " " $7 " " $8 "\n"}'
	i=`expr $i + 1`
    done
    echo " "
    i=0
    while test $i -lt $tape_count
	do
	echo -n "        Tape $i -            "
	temp="\$tape$i"
	eval echo $temp|awk '{printf $7 " " $8 " " $9 "\n"}'
	i=`expr $i + 1`
    done
    IFS=$ORIGIFS
    if (grep "^XWINI" $CFPROPOSED >/dev/null 2>&1) ; then
	echo "       Add. wini and tape - Information is not available."
	echo "                            Reference to Release Note or"
	echo "                            System Admin. Installation guide."
    fi
##################### Check if user really wants to change it ##############
    while :
	do
	echo -n '\nIs this correct <y/n>?  '
	read reply extra
	case "$reply" in
	    y*|Y*) echo "`date` ended extra wini configuration without change" >> $ZAPLOG
                   exit $OK ;;	# no 311 file exists, use the original flag.
	    n*|N*) break ;;
	    *) echo Invalid reponse \<$reply\>, please respecify
	esac
    done
fi
############### END of non-initial checking ######################

if [ -f ${SYSCFG}/c215g.c.cnv ]; then
	diff ${SYSCFG}/c215g.c.cnv ${SYSCFG}/c215g.c 2>&1 >/dev/null
	if [ $? -eq 0 ]; then
		echo "
There is a Release 3.0 to Release 3.4 conversion file in place.
If you configure any hard disks or tapes, this file will be overwritten
and any custom changes in your 3.0 215 configuration file will be lost.
Would you like to configure peripherals? <y/n>"
		while :; do
			read reply
			case "$reply" in
			    n*|N*)
				if (grep "^XWINI" $CFPROPOSED >/dev/null 2>&1)
				    then : "do nothing"
				    else
					echo "XWINI,Please enter data, if you know" >>$CFPROPOSED
				fi
				sed -e "/^WINI[1-7]/d" -e "/^WPART[1-7]/d" -e "/^TAPE/d" <$CFPROPOSED >$CFPROPOSED\2
				mv $CFPROPOSED\2 $CFPROPOSED
				echo "N" >$P311FLAG
				exit $OK ;;
			    y*|Y*)
				sed -e "/^XWINI/d" <$CFPROPOSED >$CFPROPOSED\2
				mv $CFPROPOSED\2 $CFPROPOSED
				break ;;
	                    *) echo Invalid reponse \<$reply\>, please respecify
			esac
		done
	fi
fi

while :
    do
    clear
######### specify 1st level menu (currently only one) ##########
######### get total number of extra winis, and tapes  ##########
  while :
    do
    echo -n "How many additional winchester disk drives do you have?
(not including your system wini):  "
    read wini_count
     case $wini_count in
       0|1|2|3) break ;;
       *) echo "Invalid response. Type numeric <0|1|2|3>" ;;
     esac
  done
  while :
    do
    echo -n "\nHow many tape drives do you have?  "
    read tape_count
     case $tape_count in
       0|1|2) break ;;
       *) echo "Invalid response. Type numeric <0|1|2>" ;;
     esac
  done
############### for each wini - prompt user for its size ##################
    i=1
    while test $i -le $wini_count
	do
	clear
	cat <<HERE
--------------------------------------------------------------(Winchesters)
	    Specify Additional Winchester $i type

               Unformatted Capacity         (Formatted Capacity)

	a)  40MB Quantum Winchester disk (Quantum 36 Megabyte drive)
        b)  85MB Maxtor Winchester disk (Maxtor 72 Megabyte drive)
        c)  105MB Maxtor Winchester disk (Maxtor 89 Megabyte drive)
        d)  140MB Maxtor Winchester disk (Maxtor 121 Megabyte drive)
        e)  86MB Toshiba Winchester disk (Toshiba 75 Megabyte drive)
        f)  51MB Seagate Winchester disk (Seagate 43 Megabyte drive)
        g)  170MB Maxtor Winchester disk (Maxtor 150 Megabyte drive)
        h)  380MB Maxtor Winchester disk (Maxtor 323 Megabyte drive)

	q)  Quit to main menu (and lose changes)

	?)  Get an explanation of these options

HERE
        echo -n "Enter selection? "
        read reply extra
	case "$reply" in
	    a|A)
		eval wini$i="WINI$i,/dev/w$i,36M,40M,QNTM36MB,40MB\ Winchester\ disk"
		eval wpart$i=\"WPART\"$i\"e,/dev/w\"$i\"e,35982,w\"$i\"e,/dev/usr`expr $i + 1`,3998,8,2\"
		i=`expr $i + 1`
		;;
	    b|B)
		eval wini$i="WINI$i,/dev/w$i,72M,85M,MXTR72,85MB\ Winchester\ disk"
		eval wpart$i=\"WPART\"$i\"e,/dev/w\"$i\"e,72126,w\"$i\"e,/dev/usr`expr $i + 1`,4007,8,2\"
		i=`expr $i + 1`
		;;
	    c|C)
		eval wini$i="WINI$i,/dev/w$i,89M,105M,MXTR89,105MB\ Winchester\ disk"
		eval wpart$i=\"WPART\"$i\"e,/dev/w\"$i\"e,88884,w\"$i\"e,/dev/usr`expr $i + 1`,4445,8,2\"
		i=`expr $i + 1`
		;;
	    d|D)
		eval wini$i="WINI$i,/dev/w$i,121M,140M,MXTR121,140MB\ Winchester\ disk"
		eval wpart$i=\"WPART\"$i\"e,/dev/w\"$i\"e,121212,w\"$i\"e,/dev/usr`expr $i + 1`,4662,8,2\"
		i=`expr $i + 1`
		;;
	    e|E)
		eval wini$i="WINI$i,/dev/w$i,75M,86M,TSBA75,86MB\ Winchester\ disk"
		eval wpart$i=\"WPART\"$i\"e,/dev/w\"$i\"e,73062,w\"$i\"e,/dev/usr`expr $i + 1`,4059,8,2\"
		i=`expr $i + 1`
		;;
	    f|F)
		eval wini$i="WINI$i,/dev/w$i,43M,51M,SEAG43,51MB\ Winchester\ disk"
		eval wpart$i=\"WPART\"$i\"e,/dev/w\"$i\"e,43290,w\"$i\"e,/dev/usr`expr $i + 1`,4329,8,2\"
		i=`expr $i + 1`
		;;
	    g|G)
		eval wini$i="WINI$i,/dev/w$i,150M,170M,MXTR150,170MB\ Winchester\ disk"
		eval wpart$i=\"WPART\"$i\"e,/dev/w\"$i\"e,150804,w\"$i\"e,/dev/usr`expr $i + 1`,4869,8,4\"
		i=`expr $i + 1`
		;;
	    h|H)
		eval wini$i="WINI$i,/dev/w$i,323M,380M,MXTR323,380MB\ Winchester\ disk"
		eval wpart$i=\"WPART\"$i\"e,/dev/w\"$i\"e,323172,w\"$i\"e,/dev/usr`expr $i + 1`,6876,8,8\"
		i=`expr $i + 1`
		;;
	    q*|Q*)
		exit $QUIT
		;;
	    \?|help|Help)
		clear
		more -c $SCPPATH/scpic.1.hlp
		echo '* * Press RETURN to continue * *'
		read reply
		;;
	    *)
		echo "Invalid action <$reply>, Press RETURN to continue\n"
		read reply
		;;
	esac
    done
################## Configure # of tapes ################################
    i=0
    while test $i -lt $tape_count
	do
	eval tape$i="TAPE$i,/dev/rmt$i,45M,45M,450,1000,45MB\ Streamer\ tape"
	i=`expr $i + 1`
    done
    ORIGIFS=$IFS
    IFS=,
    clear
############### Show user configuration and verify ######################
    echo "You have specified the following peripheral configuration:\n"
    echo -n "        System Wini 0 -     "
    echo $wini0 | awk '{printf $6 " " $7 " " $8 "\n"}'
    i=1
    while test $i -le $wini_count
	do
	echo -n "        Additional Wini $i - "
	temp="\$wini$i"
	eval echo $temp|awk '{printf $6 " " $7 " " $8 "\n"}'
	i=`expr $i + 1`
    done
    echo " "
    i=0
    while test $i -lt $tape_count
	do
	echo -n "        Tape $i -            "
	temp="\$tape$i"
	eval echo $temp|awk '{printf $7 " " $8 " " $9 "\n"}'
	i=`expr $i + 1`
    done
    IFS=$ORIGIFS
    while :
	do
	echo -n '\nIs this correct <y/n>?  '
	read reply extra
	case "$reply" in
	    y*|Y*) break ;;
	    n*|N*) continue 2 ;;
	    *) echo Invalid reponse \<$reply\>, please respecify
	esac
    done
#################### Add new configuration to cfproposed ###############
    i=1
    if [ -f $SWITCHFLAG -o $INITIAL != Y ] ; then
	sed -e "/^WINI[1-7]/d" -e "/^WPART[1-7]/d" -e "/^TAPE/d" <$CFPROPOSED >$CFPROPOSED\2
	mv $CFPROPOSED\2 $CFPROPOSED
    fi
    while test $i -le $wini_count
	do
	temp="\$wini$i"
	temp1=`eval echo $temp`
	echo $temp1 >> $CFPROPOSED
	temp="\$wpart$i"
	temp1=`eval echo $temp`
	echo $temp1 >> $CFPROPOSED
	i=`expr $i + 1`
    done
    i=0
    while test $i -lt $tape_count
	do
	temp="\$tape$i"
	temp1=`eval echo $temp`
	echo $temp1 >> $CFPROPOSED
	i=`expr $i + 1`
    done
    echo "Y" > $MAKEFLAG           # make new xenix
    echo "Y" > $P311FLAG
    echo "`date` ended extra wini configuration" >> $ZAPLOG
    exit $MADE
    break
done
