# Copyright Intel Corp. 1985,1986
# Author:  Jim Jackson, modified by Ed Reeder

# scp311fmt.ss_version[] ="@(#) scp311fmt.ss $State: XENIX_R3-5_U2 $ $Date: 88/02/19 14:40:02 $";
# format and make an additional Winchester disk
# first parm is disk number (e.g., 1 for /dev/rw1)
# second parm is disk type  (e.g., QNTM36MB)

# It is O.K. to have some non-zero return codes here
set +e

filesystem=`expr $1 + 1`
/etc/umount /dev/usr$filesystem >/dev/null 2>&1
echo "If the additional Winchester to be formatted is in a
separate peripheral box, make sure that it is powered on.
Press RETURN when the device is ready"
read resp

case $2 in
   QNTM36MB)
      echo "This device takes about 10 minutes to format" > /dev/tty
      if format -S -l 3999 -i 4 -b -s 9 -fh 8 -c 512 -g 1024 -A 4000 -n 10 -t 4084 -rh 0 -z 5 /dev/rw$1 ; then
	 echo "Format complete, making file system"
      else
	 echo "* * * Error in formatting /dev/rw$1"
	 exit 1
      fi
      ;;
   MXTR72)
      echo "This device takes about 20 minutes to format" > /dev/tty
      if format -S -l 8015 -i 4 -b -s 9 -fh 8 -c 1024 -g 1024 -A 8016 -n 20 -t 8180 -rh 0 -z 5 /dev/rw$1 ; then
	 echo "Format complete, making file system"
      else
	 echo "* * * Error in formatting /dev/rw$1"
	 exit 1
      fi
      ;;
   MXTR89)
      echo "This device takes about 20 minutes to format" > /dev/tty
      if format -S -l 9877 -i 4 -b -s 9 -fh 11 -c 918 -g 1024 -A 9878 -n 18 -t 10083 -rh 0 -z 5 /dev/rw$1 ; then
	 echo "Format complete, making file system"
      else
	 echo "* * * Error in formatting /dev/rw$1"
	 exit 1
      fi
      ;;
   MXTR121)
      echo "This device takes about 30 minutes to format" > /dev/tty
      if format -S -l 13469 -i 4 -b -s 9 -fh 15 -c 918 -g 1024 -A 13470 -n 18 -t 13751 -rh 0 -z 5 /dev/rw$1 ; then
	 echo "Format complete, making file system"
      else
	 echo "* * * Error in formatting /dev/rw$1"
	 exit 1
      fi
      ;;
   TSBA75)
      echo "This device takes about 20 minutes to format" > /dev/tty
      if format -S -l 8119 -i 4 -b -s 9 -fh 10 -c 830 -g 1024 -A 8120 -n 16 -t 8286 -rh 0 -z 5 /dev/rw$1 ; then
	 echo "Format complete, making file system"
      else
	 echo "* * * Error in formatting /dev/rw$1"
	 exit 1
      fi
      ;;
   SEAG43)
      echo "This device takes about 10 minutes to format" > /dev/tty
      if format -S -l 4811 -i 4 -b -s 9 -fh 6 -c 820 -g 1024 -A 4812 -n 16 -t 4910 -rh 0 -z 5 /dev/rw$1 ; then
	 echo "Format complete, making file system"
      else
	 echo "* * * Error in formatting /dev/rw$1"
	 exit 1
      fi
      ;;
   MXTR150)
      echo "This device takes about 30 minutes to format" > /dev/tty
      if format -S -l 8378 -i 1 -b -s 18 -fh 7 -c 1223 -g 1024 -A 8379 -n 24 -t 8550 -rh 0 -z 5 /dev/rw$1 ; then
	 echo "Format complete, making file system"
      else
	 echo "* * * Error in formatting /dev/rw$1"
	 exit 1
      fi
      ;;
   MXTR323)
      echo "This device takes about an hour to format" > /dev/tty
      if format -S -l 17954 -i 1 -b -s 18 -fh 15 -c 1223 -g 1024 -A 17955 -n 24 -t 18326 -rh 0 -z 5 /dev/rw$1 ; then
	 echo "Format complete, making file system"
      else
	 echo "* * * Error in formatting /dev/rw$1"
	 exit 1
      fi
      ;;
esac

case $2 in
   QNTM36MB)
      if mkfs -y /dev/w$1e 35982 3998 8 2 ; then
	 echo File system made
      else
	 echo "* * * Error in making file system /dev/w$1e"
	 exit 1
      fi
      ;;
   MXTR72)
      if mkfs -y /dev/w$1e 72126 4007 8 2 ; then
	 echo File system made
      else
	 echo "* * * Error in making file system /dev/w$1e"
	 exit 1
      fi
      ;;
   MXTR89)
      if mkfs -y /dev/w$1e 88884 4445 8 2 ; then
	 echo File system made
      else
	 echo "* * * Error in making file system /dev/w$1e"
	 exit 1
      fi
      ;;
   MXTR121)
      if mkfs -y /dev/w$1e 121212 4662 8 2 ; then
	 echo File system made
      else
	 echo "* * * Error in making file system /dev/w$1e"
	 exit 1
      fi
      ;;
   TSBA75)
      if mkfs -y /dev/w$1e 73062 4059 8 2 ; then
	 echo File system made
      else
	 echo "* * * Error in making file system /dev/w$1e"
	 exit 1
      fi
      ;;
   SEAG43)
      if mkfs -y /dev/w$1e 43290 4329 8 2 ; then
	 echo File system made
      else
	 echo "* * * Error in making file system /dev/w$1e"
	 exit 1
      fi
      ;;
   MXTR150)
      if mkfs -y /dev/w$1e 150804 4869 8 4 ; then
	 echo File system made
      else
	 echo "* * * Error in making file system /dev/w$1e"
	 exit 1
      fi
      ;;
   MXTR323)
      if mkfs -y /dev/w$1e 323172 6876 8 8 ; then
	 echo File system made
      else
	 echo "* * * Error in making file system /dev/w$1e"
	 exit 1
      fi
      ;;
esac

yes 'y'|/etc/fixbb -c -e /dev/w$1err >/dev/null 2>&1

ln /dev/w$1e /dev/usr$filesystem >/dev/null 2>&1
ln /dev/rw$1e /dev/rusr$filesystem >/dev/null 2>&1
mkdir /usr$filesystem >/dev/null 2>&1

return="2"
while [ $return = "2" ] ; do
   echo Check file system for consistency
   fsck -y /dev/w$1e
   /etc/mount /dev/usr$filesystem /usr$filesystem
   return=$?
done
#
# fix up the lost+found directories.
#
echo "\nFix up lost+found directories."
cd /usr$filesystem/lost+found
COM1="1 2 3 4 5 6 7 8 9 10 11 12 13"
COM2="a b c d e f g h i j k l m n o p q r s t u v w x y z aa bb cc"
for i in ${COM1} ; do
	echo -n .
	for j in ${COM2} ; do
		> ${i}${j}
	done
done
rm -f *
echo
sync
#
echo "The available disk space is "
if [ -f /iDISbin/Adf ] ; then
    /iDISbin/Adf
else
   echo "File System           Avail. 1024-byte blocks\n"
   df
fi
