# Copyright Intel Corp. 1985
# Author:  Ed Reeder

# scpbuild.1.ss_version[] ="@(#) scpbuild.1.ss $State: XENIX_R3-5 $ $Date: 87/07/14 14:17:26 $";

# see if any extra wini's exist
egrep \^WINI[1-7] $CFPROPOSED > /dev/null ||  exit

awk -F, '
   /^WINI[1-7]/ {
      if( foundone != "YES" ) {
         print "# Format the additional disks and make required file systems."
         print "# THIS SHOULD ONLY BE RUN ONCE, TO INITIALLY FORMAT THE DISKS."
         print "# To enforce this it will be removed at completion."
         print "echo Checking for added winchester-drives within your /xenix kernel ...\n"
         print "nm /xenix | egrep -n Piw1 >/dev/null 2>&1 "
	 print "if [ $? != 0 ] ; then"
	 print "    echo \"XENIX \(/xenix\) does not contain added winchester-devices."
	 print "If you have configured in added winchester-devices please"
	 print "move that kernel to /xenix and restart this procedure."
	 print "If winchester-devices have not been configured in, please"
	 print "refer to the appropriate installation procedure before"
	 print "continuing with this procedure\n\""
	 print "    echo \"No added winchester-devices in kernel.\" >> '$ZAPLOG'"
	 print "    exit 1"
	 print "fi"
         print "#"
         print "# Mount the /usr file system, so scp311fmt.ss can run"
         print "#"
         print "counter=1"
         print "/etc/mount /dev/usr /usr >/dev/null 2>&1"
         print "if test $? = 2; then"
         print "   echo Cleaning /dev/usr"
         print "   fsck -y /dev/usr"
         print "   /etc/mount /dev/usr /usr"
         print "   counter=`expr $counter + 1`"
         print "   return=$?"
         print "   while [ $return = 2 ]"
         print "   do"
         print "      echo The /usr file system did not properly mount."
         print "      echo Cleaning /dev/usr"
         print "      fsck /dev/usr"
         print "      echo Mounting the /usr file system."
         print "      /etc/mount /dev/usr /usr"
         print "      return=$?"
         print "      if [ $counter -gt 3 ];"
         print "          then  return=0"
         print "      fi"
         print "   done"
         print "fi >/dev/console 2>&1"
         foundone = "YES"
      }
      # Format the 311 expansion disks, if any
      disk = substr( $1, 5, 1 )        # Get disk number
      filesystem = disk + 1            # Make file system number
      type = $5                        # Get type of disk (e.g., QNTM36MB)
      if( disk == 1 ) number = "first"
      if( disk == 2 ) number = "second"
      if( disk == 3 ) number = "third"
      if( disk == 4 ) number = "fourth"
      if( disk == 5 ) number = "fifth"
      if( disk == 6 ) number = "sixth"
      if( disk == 7 ) number = "seventh"
      print "while : ; do"
      print "   echo \"\\nAbout to format the " number " additional Winchester disk.\""
      print "   echo Used for the /usr" filesystem " file system."
      print "   echo If you have data on this disk that you wish preserved,"
      print "   echo \"respond \\047n\\047 to the next prompt.\""
      print "   echo This is provided for systems that have previously been configured."
      print "   echo \"For an initial configuration, you should respond \\047y\\047.\""
      print "   while :"
      print "      do"
      print "      echo -n \"\\nDo you want to format the disk <y/n>? \""
      print "      read reply"
      print "      case $reply in"
      print "         y*|Y*) break ;;"
      print "         n*|N*)"
      print "            echo Winchester disk NOT formatted."
      print "            echo `date` Disk " disk " NOT formatted >> '$ZAPLOG'"
      print "            break 2 ;;"
      print "         *) echo Invalid response \\<$reply\\>, please respecify."
      print "      esac"
      print "   done"
      print "   '$SCPPATH'/scp311fmt.ss " disk " " type
      print "   break"
      print "done >/dev/console 2>&1"
   }
   END {
      if( foundone == "YES" ) {
         print "# Remove this file, so it can run only once"
         print "chmod 600 '$ETC'/scpinitialfmt"
         print "sync;sleep 2"
         print "mv '$ETC'/scpinitialfmt '$ETC'/scp311fmt-"
         print "sync"
      }
  }
' $CFPROPOSED > $ETC/scpinitialfmt

# Set proper access rights
chmod 500 $ETC/scpinitialfmt
