# Copyright Intel Corp. 1985,1986
# Author:  Ed Reeder
#
# Modified:  Colin Hulme, Intel Corporation
#    4-17-86 to work with Xenix 3.4
#    5-02-86 to handle multiple communications boards
#    5-03-86 split out from scpport to allow early detection of console
#            terminal type.
#    9-16-87 Console port label set to N/A initially, <null> causes problems.
#
# scpconsole.ss_version[] ="@(#) scpconsole.ss $State: XENIX_R3-5_U1 $ $Date: 87/09/16 13:48:15 $";

echo "`date` started console " >> $ZAPLOG

> $CFPROPOSED	# clear out proposed config file
cp $CURRENT $CFPROPOSED >/dev/null 2>&1

IFS=,
set `egrep \^SYSTYPE $CFPROPOSED` x
IFS=$ORIGIFS
case $2 in
	310) CONLABEL=J20 ;;
	AP)  CONLABEL=J31 ;;
	320) CONLABEL=J11 ;;
	*)   CONLABEL=N/A ;;
esac

reply=N
# Construct initial console configuration.
egrep "^CONSOLE" $CFPROPOSED >/dev/null 2>&1
if [ $? != 0 ] ; then
   echo "CONSOLE,0,/dev/console,console,$CONLABEL,T,E,N/A,unknown,unknown" >> $CFPROPOSED

# Review existing console spec.
else
   # Get console and termboard values
   IFS=,
   exec < $CFPROPOSED
   while :
      do
      read word x2 x3 x4 label x6 x7 x8 x9 TYPE
      case "$word" in
         CONSOLE) break ;;
         *) continue
      esac
   done
   IFS=$ORIGIFS
   exec < /dev/tty
   while :
      do
      echo "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"
      echo "Console terminal type is  $TYPE"
      # See if user specified this type "by hand".  If so, show termcap name.
      # Use grep, TYPE might contain a regular expression
      grep ".,$TYPE," $SCPPATH/devices/terminals* > /dev/null
      if [ $? -eq 1 ] ; then
         IFS=,
         set `egrep \^CONSOLE $CFPROPOSED`
         IFS=$ORIGIFS
         PRINTTERMCAP=$9
         echo "Terminal name is $PRINTTERMCAP"
      fi
      echo -n 'Is this correct <y/n>? '
      read reply extra
      case "$reply" in
         y*|Y*) break ;;
         n*|N*) reply=N
            break ;;
         *) echo Invalid response \<$reply\>, Press RETURN to continue
	    read reply ;;
      esac
   done
fi

# BEGIN  Console (if)
# Capture console's terminal type
if [ "$reply" = N ] ; then
	idx=0
	PRINTTERMCAP=unknown
	TYPE=unknown
	echo "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"
	while :
	  do
		MUSTANSWER=N $SCPPATH/scpterms.ss
		case "$?" in
			$OK)	IFS=,
				set `cat < $SCPPATH/configurations/term.tmp`
				TYPE=$1
				PRINTTERMCAP=$2
				IFS=$ORIGIFS
				break ;;
			$RESTART) continue ;;
			$QUIT)	break ;;
		esac
	done
	sed "s|^\(CONSOLE,0,/dev/console,console,\).*|\1$CONLABEL,T,E,N/A,$PRINTTERMCAP,$TYPE|" < $CFPROPOSED > $CFPROPOSED\2
	mv $CFPROPOSED\2 $CFPROPOSED
fi
# END  Console (if)

echo "`date` ended console " >> $ZAPLOG
exit $OK
