# Copyright Intel Corp. 1985,1986
# Author:  Ed Reeder
#
# Modified:  Colin Hulme, Intel Corporation
#    4-24-86 to work with Xenix 3.4
#
# scpec.ss_version[] ="@(#) scpec.ss $State: XENIX_R3-5 $ $Date: 87/06/15 09:22:45 $";

echo "`date` started existing configuration specification" >> $ZAPLOG
what $SCPPATH/scpec.ss >> $ZAPLOG

IFS=,
set `egrep \^PRINTER0 $CFPROPOSED` "x"  # Get parallel printer label
IFS=$ORIGIFS
PPLABEL=$3
export PPLABEL
while :
   do
   clear
   cat  <<-HERE
-----------------------------------------------------------------------(Exist)
        Modify your existing system configuration

        a)   Parallel printer configuration
        b)   Terminal/modem/serial printer configuration
        c)   Default printer specification
        d)   311 or additional wini/tape configuration
        e)   Time zone specification
        f)   Maximum file size specification
        g)   Show existing configuration

        m)   Make all specified changes

        q)   Quit to main menu (and lose changes)

        ?)   Get an explanation of these options

HERE
   echo -n "Enter selection? "
   read reply extra
   case "$reply" in
      a|A)
        while :
           do
           echo "One moment, please ..."
           $SCPPATH/scplp.ss
           return=$?
           case $return in
              $OK) break ;;
              $RESTART) continue ;;
              $MADE) echo "Who knows???" ;;      # CHECK ON THIS
              $QUIT) exit $QUIT ;;
           esac
        done
        ;;

      b|B)
        while :
           do
           echo "One moment, please ..."
           $SCPPATH/scpport.ss
           return=$?
           case $return in
              $OK) break ;;
              $RESTART) continue ;;
              $MADE) echo "Who knows???" ;;      # CHECK ON THIS
              $QUIT) exit $QUIT ;;
           esac
        done
        ;;
      c|C)      # Default line printer
        while :
           do
           $SCPPATH/scplpdflt.ss -Modify
           return=$?
           case $return in
              $OK) break ;;
              $RESTART) continue ;;
              $MADE) echo "Who knows???" ;;      # CHECK ON THIS
              $QUIT) exit $QUIT ;;
           esac
        done
        ;;
      d|D)
        while :
            do
            echo "One moment, please ..."
            $SCPPATH/scp311.ss
            return=$?
            case $return in
                $OK|$MADE) break;;
                $RESTART) continue ;;
                $QUIT) exit $QUIT ;;
            esac
        done
        ;;
      e|E)        # Time zone
        while :
           do
           echo "One moment, please ..."
           $SCPPATH/scptz.ss
           return=$?
           case $return in
              $OK) break ;;
              $RESTART) continue ;;
              $MADE) echo "Who knows???" ;;        # CHECK ON THIS
              $QUIT) exit $QUIT ;;
           esac
        done
        ;;
      f|F)        # Max File Size
        while :
           do
           echo "One moment, please ..."
           $SCPPATH/scpmf.ss
           return=$?
           case $return in
              $OK) break ;;
              $RESTART) continue ;;
              $MADE) echo "Who knows???" ;;        # CHECK ON THIS
              $QUIT) exit $QUIT ;;
           esac
        done
        ;;

      g|G)
	clear
	$SCPPATH/scpshow.ss
	echo "\n* * Press RETURN to continue * *"
	read reply extra
	;;

      m|M)
        cmp $CURRENT $CFPROPOSED > /dev/null 2>&1
        if [ $? -eq 0 -a $INITIAL = "N" ] ; then
echo "* * Your proposed configuration is the same as your existing configuration.
* * Either quit or make additional configuration changes
* * Press RETURN to continue * *"
           read reply
           continue
        fi
        while :
           do
           echo -n 'Are you certain you wish to make the configuration at this time <y/n>? '
           read reply extra
           case "$reply" in
              y*|Y*) break ;;
              n*|N*) continue 2 ;;
              *) echo Invalid response \<$reply\>, please respecify
           esac
        done

        # Double check if the default printer needs to be changed
        while :
           do
           $SCPPATH/scplpdflt.ss -Make
           return=$?
           case $return in
              $OK) break ;;
              $RESTART) continue ;;
              $MADE) echo "Who knows???" ;;        # CHECK ON THIS
              $QUIT) exit $QUIT ;;
           esac
        done

        clear
echo "Making the configuration will take approximately 10 minutes.
Building configuration instructions . . ."

trap "" 3              # cannot allow use to ctl-\ out after this point
if [ -f $P311FLAG ] ; then
	set `cat $P311FLAG`
	INITIAL311=$1 ;  export INITIAL311
fi

env - SYSDIR=$SYSDIR ZAPLOG=$ZAPLOG INSTPROPOSED=$INSTPROPOSED CFPROPOSED=$CFPROPOSED SCPPATH=$SCPPATH INITIAL311=$INITIAL311 INITIAL=$INITIAL MAKEFLAG=$MAKEFLAG MAKESTAT=$MAKESTAT SCPDEBUG=$SCPDEBUG VERSION=$VERSION OK=$OK PRINTERFLAG=$PRINTERFLAG $SCPPATH/scpbuild.ss

env - SCPDEBUG=$SCPDEBUG INSTPROPOS_2=$INSTPROPOS_2 ZAPLOG=$ZAPLOG SCPPATH=$SCPPATH CFPROPOSED=$CFPROPOSED INITIAL=$INITIAL $SCPPATH/scpbuild.2.ss

        echo "\nMaking configuration . . ."
        chmod u+x $INSTPROPOSED $INSTPROPOS_2
        # Put stdout and stderr into log
        IFS=$ORIGIFS
        { env - $INSTPROPOS_2; echo $? > /tmp/$$rtn; } 2>&1 | tee -a $ZAPLOG
        return_2=`cat /tmp/$$rtn`
        { env - ZAPLOG=$ZAPLOG SCPPATH=$SCPPATH CFPROPOSED=$CFPROPOSED INITIAL=$INITIAL MAKEFLAG=$MAKEFLAG $INSTPROPOSED; echo $? > /tmp/$$rtn; } 2>&1 | tee -a $ZAPLOG
        return=`cat /tmp/$$rtn`
        case $return in
           $OK|$MADE)
              # Save current configuration and instructions away as n+1
              if [ -f $CURRENT ] ; then
                 set `ls $SCPPATH/configurations/cf.* |egrep "cf\.[1-9s]" |wc -l`
                 n=$1
                 mv $CURRENT $SCPPATH/configurations/cf\.$n
                    if [ -f $INSTRUCTIONS ] ; then
                       	 mv $INSTRUCTIONS $SCPPATH/configurations/inst\.$n
                       	 mv $INSTRUCTIO_2 $SCPPATH/configurations/inst_2\.$n
		    fi
                 echo "`date` old conf. saved as cf.$n" >> $ZAPLOG
                 echo "`date` old inst. saved as inst.$n" >> $ZAPLOG
              fi
              mv $CFPROPOSED $CURRENT
              mv $INSTPROPOSED $INSTRUCTIONS
              mv $INSTPROPOS_2 $INSTRUCTIO_2
              exit $return
              ;;
           *)
              echo '* * Problems arose during the execution of the shellscript'
              cp $INSTPROPOSED $SCPPATH/configurations/ProblemScript
              echo $SCPPATH/configurations/ProblemScript
              cp $CFPROPOSED $SCPPATH/configurations/ProblemConf
echo "Existing configuration is preserved.
* * Press RETURN to continue * *"
              read reply
              exit $CANCEL
        esac
        ;;

      q*|Q*)
        exit $QUIT
        ;;
      \?|help|Help)
        clear
        more -c $SCPPATH/scpec.0.hlp
        echo '* * Press RETURN to continue * *'
        read reply
        ;;

      *)
        echo Invalid action \<$reply\>, Press RETURN to continue
        read reply
        ;;
   esac
done
