# Copyright Intel Corp. 1985,1986,1987
# Author:  Ed Reeder & J. Jackson
#
# Modified:  Colin Hulme, Intel Corporation
#    4-16-86 to work with Xenix 3.4
#    5-02-86 to handle different comm configurations
#    2-16-87 bill ramstad
#	use the information gs gives us about terminal controllers,
#	rather than bother the user with questions.
#    3-23-87 seckin
#	removed the extra clear, the $MADE case after scplpdflt.ss,
#	and the comma at tail of TERMBOARD entries in current file.
#    7-14-87 seckin
#	fixed the printer connector label $PPLABEL.
#
# scpic.ss_version[] ="@(#) scpic.ss $State: XENIX_R3-5 $ $Date: 87/07/14 17:23:56 $";

echo "`date` started initial configuration specification" >> $ZAPLOG
what $SCPPATH/scpic.ss >> $ZAPLOG
#
case $SYSTYPE in
	310) PPLABEL=J24 ;;
	AP)  PPLABEL=J33 ;;
	320) PPLABEL=" " ;;
esac
export PPLABEL
#
# Capture system's board set and disk configuration
#
echo '\nOne moment, please ...'
MAXBOARDS=4
BDCOUNT=0
BOARD=0
MAX188BDS=2

while [ $BDCOUNT -lt $MAXBOARDS ] ;
	do
	BADDR=
	BPORT=
	BINT=
	set `gs -xt$BDCOUNT` none
	T=$1
	LINES=$3
	# handle getting back hex values -- a bad vrs of gs
	case $LINES in
		a|A) LINES=10 ;;
		b|B) LINES=11 ;;
		c|C) LINES=12 ;;
	esac
	if [ "$T" = none ] ; then
		BDCOUNT=`expr $BDCOUNT + 1`
		continue
	fi
	case $T in
		# note:  the system identifies, and thus,
		# returns 546/547/188 boards
		# before 544 boards.  otherwise, might have to
		# be a little more exotic to pick up 544's interspersed
		# with 546/547/188.  can only allow up to 3 546/547/188
		# boards.
		546*|547*|188*) if [ $BOARD -gt $MAX188BDS ] ; then
					BDCOUNT=`expr $BDCOUNT + 1`
					continue
				fi
				BADDR="0x$4"
				BPORT="0x$5"
				case "$4" in
					f90000|F90000) BINT="03" ;;
					fa0000|FA0000) BINT="02" ;;
					fb0000|FB0000) BINT="0100" ;;
					f80000|F80000) BINT="0101" ;;
				esac ;;
	esac
	eval TERMBOARD$BOARD=$T
	temp=\$TERMBOARD$BOARD
	IFS=,
	set `eval egrep \"\^$temp.\$BOARD\" $SCPPATH/devices/makearguments`
	makeargs=$2
	IFS=$ORIGIFS
	eval echo \"TERMBOARD\$BOARD,$temp,\$makeargs\,$LINES\,$BADDR\,$BPORT\,$BINT\" \>\> \$CFPROPOSED
	BOARD=`expr $BOARD + 1`
	BDCOUNT=`expr $BDCOUNT + 1`
done
if [ `gs -p` -ne 386 ] ; then
	T=none
	eval TERMBOARD$BOARD=$T
	temp=\$TERMBOARD$BOARD
	IFS=,
	set `eval egrep \"\^$temp.\$BOARD\" $SCPPATH/devices/makearguments`
	makeargs=$2
	IFS=$ORIGIFS
	LINES=1
	BADDR=
	BPORT=
	BINT=
	eval echo \"TERMBOARD\$BOARD,$temp,\$makeargs\,$LINES\,$BADDR\,$BPORT\,$BINT\,\" \>\> \$CFPROPOSED
	BOARD=`expr $BOARD + 1`
fi
$SCPPATH/scpic1.ss
return=$?
case $return in
	$QUIT) exit $QUIT ;;
esac

# Determine default printer, if any
while :
    do
    $SCPPATH/scplpdflt.ss -Make
    return=$?
    case $return in
	$OK) break ;;
	$RESTART) continue ;;
	$QUIT) exit $QUIT ;;
    esac
done

clear
$SCPPATH/scpshow.ss

while :
   do
echo -n "\nDo you wish to build your configuration?
(a \047no\047 will allow you to change any of the above parameters) <y/n>? "
   read reply extra
   case "$reply" in
      y*|Y*) break ;;
      n*|N*) echo "SWITCH" > $SWITCHFLAG
             $SCPPATH/scpec.ss
             return=$?
             case "$return" in
                 $OK)   exit $OK ;;
                 $QUIT) exit $QUIT ;;
                 $MADE) exit $MADE ;;
                 $CANCEL) exit $CANCEL ;;
             esac ;;
      *) echo "Invalid action <$reply>, please respecify\n"
   esac
done
clear
echo "Making the configuration will take approximately 10 minutes.
Building configuration instructions . . ."

trap "" 3              # cannot allow use to ctl-\ out after this point
if [ -f $P311FLAG ] ; then
	set `cat $P311FLAG`
	INITIAL311=$1
fi

env - SYSDIR=$SYSDIR ZAPLOG=$ZAPLOG INSTPROPOSED=$INSTPROPOSED CFPROPOSED=$CFPROPOSED SCPPATH=$SCPPATH INITIAL311=$INITIAL311 INITIAL=$INITIAL MAKEFLAG=$MAKEFLAG MAKESTAT=$MAKESTAT SCPDEBUG=$SCPDEBUG VERSION=$VERSION OK=$OK PRINTERFLAG=$PRINTERFLAG $SCPPATH/scpbuild.ss

env - SCPDEBUG=$SCPDEBUG INSTPROPOS_2=$INSTPROPOS_2 ZAPLOG=$ZAPLOG SCPPATH=$SCPPATH CFPROPOSED=$CFPROPOSED INITIAL=$INITIAL $SCPPATH/scpbuild.2.ss

echo "\nMaking configuration . . ."
chmod u+x $INSTPROPOSED $INSTPROPOS_2
# Put stdout and stderr into log
IFS=$ORIGIFS
{ env - $INSTPROPOS_2; echo $? > /tmp/$$rtn; } 2>&1 | tee -a $ZAPLOG
return_2=`cat /tmp/$$rtn`
{ env - ZAPLOG=$ZAPLOG SCPPATH=$SCPPATH CFPROPOSED=$CFPROPOSED INITIAL=$INITIAL MAKEFLAG=$MAKEFLAG $INSTPROPOSED; echo $? > /tmp/$$rtn; } 2>&1 | tee -a $ZAPLOG
return=`cat /tmp/$$rtn`
case $return in
   $MADE|$OK)
      if [ -f $CURRENT ] ; then
         # Save current configuration and instructions away as n+1
         set `ls $SCPPATH/configurations/cf.* | egrep "cf\.[1-9s]" | wc -l`
         n=$1
         mv $CURRENT $SCPPATH/configurations/cf\.$n
         if [ -f $INSTRUCTIONS ] ; then
            mv $INSTRUCTIONS $SCPPATH/configurations/inst\.$n
            mv $INSTRUCTIO_2 $SCPPATH/configurations/inst_2\.$n
	 fi
         echo "`date` old conf. saved as cf.$n" >> $ZAPLOG
         echo "`date` old inst. saved as inst.$n" >> $ZAPLOG
      fi
      mv $CFPROPOSED $CURRENT
      mv $INSTPROPOSED $INSTRUCTIONS
      mv $INSTPROPOS_2 $INSTRUCTIO_2
      exit $return
      ;;
   *)
      echo '* * Problems arose during the execution of the shellscript'
      cp $INSTPROPOSED $SCPPATH/configurations/ProblemScript
      cp $INSTPROPOS_2 $SCPPATH/configurations/ProblemScri_2
      echo $SCPPATH/configurations/ProblemScript
      echo $SCPPATH/configurations/ProblemScri_2
      cp $CFPROPOSED $SCPPATH/configurations/ProblemConf
echo "Existing configuration is preserved.
* * Press RETURN to continue * *"
      read reply
      exit $CANCEL
esac
