# Copyright Intel Corp. 1985,1986,1987
# Author:  Ed Reeder & J.Jackson
#
# Capture wini-0 type and set-up for 311 as required
# Capture Timezone, Line Printer, Terminal, and Max File Size
# information for standard configurations
#
# Modified:
#   4-16-86	Colin Hulme, Intel Corporation
#		to work with Xenix 3.4
#   2-27-87	seckin
#		Added support for MXTR89 and TSBA75.
#   3-23-87	seckin
#		Removed the extra clear, indentations, and $MADE cases.
#   2-19-88	seckin
#		Added support for SEAG43, MXTR150, and MXTR323.
#
# scpic1.ss_version[] ="@(#) scpic1.ss $State: XENIX_R3-5_U2 $ $Date: 88/02/19 14:43:48 $";

echo "FLOPPY0,/dev/dvf0,360K,500K,360KB Floppy disk" >> $CFPROPOSED
#
# Get the type for the first wini.
#
reply=`sed -n '/#define\(.*\)[	 ]1 *$/{
	s/#define[	 ]*//
	s/[	 ]*1$//
	p
	}' /etc/c215g.c`
case "$reply" in
  CMI15MB)
   echo "WINI0,/dev/w0,15M,19M,CMI15MB,19MB Winchester disk" >> $CFPROPOSED
   echo "WPART0a,/dev/w0a,14886,w0a,/dev/root,2978,8,2" >> $CFPROPOSED
  ;;
  QNTM36MB)
   echo "WINI0,/dev/w0,36M,40M,QNTM36MB,40MB Winchester disk">> $CFPROPOSED
   echo "WPART0a,/dev/w0a,9216,w0a,/dev/root,3072,8,2" >> $CFPROPOSED
   echo "WPART0c,/dev/w0c,22662,w0c,/dev/usr,3238,8,2" >> $CFPROPOSED
  ;;
  MXTR72)
   echo "WINI0,/dev/w0,72M,85M,MXTR72,85MB Winchester disk">> $CFPROPOSED
   echo "WPART0a,/dev/w0a,9216,w0a,/dev/root,3072,8,2" >> $CFPROPOSED
   echo "WPART0c,/dev/w0c,53694,w0c,/dev/usr,3580,8,2" >> $CFPROPOSED
  ;;
  MXTR89)
   echo "WINI0,/dev/w0,89M,105M,MXTR89,105MB Winchester disk">> $CFPROPOSED
   echo "WPART0a,/dev/w0a,9216,w0a,/dev/root,3072,8,2" >> $CFPROPOSED
   echo "WPART0c,/dev/w0c,63252,w0c,/dev/usr,3722,8,2" >> $CFPROPOSED
  ;;
  MXTR121)
   echo "WINI0,/dev/w0,121M,140M,MXTR121,140MB Winchester disk">> $CFPROPOSED
   echo "WPART0a,/dev/w0a,9216,w0a,/dev/root,3072,8,2" >> $CFPROPOSED
   echo "WPART0c,/dev/w0c,95580,w0c,/dev/usr,4156,8,2" >> $CFPROPOSED
  ;;
  TSBA75)
   echo "WINI0,/dev/w0,75M,86M,TSBA75,86MB Winchester disk">> $CFPROPOSED
   echo "WPART0a,/dev/w0a,9216,w0a,/dev/root,3072,8,2" >> $CFPROPOSED
   echo "WPART0c,/dev/w0c,54630,w0c,/dev/usr,3642,8,2" >> $CFPROPOSED
  ;;
  SEAG43)
   echo "WINI0,/dev/w0,43M,51M,SEAG43,51MB Winchester disk">> $CFPROPOSED
   echo "WPART0a,/dev/w0a,9216,w0a,/dev/root,3072,8,2" >> $CFPROPOSED
   echo "WPART0c,/dev/w0c,29970,w0c,/dev/usr,3330,8,2" >> $CFPROPOSED
  ;;
  MXTR150)
   echo "WINI0,/dev/w0,150M,170M,MXTR150,170MB Winchester disk">> $CFPROPOSED
   echo "WPART0a,/dev/w0a,9216,w0a,/dev/root,3072,8,2" >> $CFPROPOSED
   echo "WPART0c,/dev/w0c,125172,w0c,/dev/usr,4636,8,4" >> $CFPROPOSED
  ;;
  MXTR323)
   echo "WINI0,/dev/w0,323M,380M,MXTR323,380MB Winchester disk">> $CFPROPOSED
   echo "WPART0a,/dev/w0a,9216,w0a,/dev/root,3072,8,2" >> $CFPROPOSED
   echo "WPART0c,/dev/w0c,297540,w0c,/dev/usr,6612,8,8" >> $CFPROPOSED
  ;;
  *)
   echo "Error in /etc/c215g.c file, restore original."
   exit 1 ;;
esac

###################### Get user peripheral info ########################
while :
    do
    $SCPPATH/scp311.ss
    return=$?
    case $return in
	$QUIT) exit $QUIT ;;
	$RESTART) continue ;;
	*) break ;;
    esac
    break
done
#
###################### Get time zone information ########################
while :
    do
    $SCPPATH/scptz.ss
    return=$?
    case $return in
	$OK) break ;;
	$RESTART) continue ;;
	$QUIT) exit $QUIT ;;
    esac
done
#
###################### Get MAX file size info ########################
while :
    do
    $SCPPATH/scpmf.ss
    return=$?
    case $return in
	$OK) break ;;
	$RESTART) continue ;;
	$QUIT) exit $QUIT ;;
    esac
done
#
###################### Get Line Printer info ########################
while :
    do
    $SCPPATH/scplp.ss
    return=$?
    case $return in
	$OK) break ;;
	$RESTART) continue ;;
	$QUIT) exit $QUIT ;;
    esac
done
#
###################### Get Terminal information ########################
while :
    do
    $SCPPATH/scpport.ss
    return=$?
    case $return in
	$OK) break ;;
	$RESTART) continue ;;
	$QUIT) exit $QUIT ;;
    esac
done

exit $OK
