: /bin/sh
#
#       Build the necessary parameters for the batch invocation
#       of the icp program cfgi215
#       This is a modification of the icp 2.1 main program.
#       Modified by Ed Reeder
#
# scpicp.ss_version[] ="@(#) scpicp.ss $State: XENIX_R3-5 $ $Date: 87/06/24 14:19:11 $";

# O.K. to have a non-zero return code (just to be safe)
set +e

makeok=true
list=""
exec < $SYSCONF/master
echo -n .
while read devn vsiz x x x x x x x x int1 int2 int3 int4; do
  case "$devn" in
    \**)  continue ;;
    debug) break   ;;
    i215)     list="$list $devn"
           eval $devn=\"$vsiz $int1 $int2 $int3 `expr $int4 : '\([0-7]*\)'`\"
           break
  esac
done
echo -n .
exec < /dev/tty
# set environment variables for icp
case $COMMENT in
      "") nodebug=true ;;
      *)  nodebug=false
esac
export nodebug
#
#       Each item in $list is the name of some device for which we
#       should invoke the configuration script (if one exists).  The
#       cfg$i script will import (and export) variables of the form
#       $vec$n, which reflect the set of interrupt vectors currently
#       in use by already selected devices.  For convenience, vector
#       information from master is also passed via $vsiz and $int?.
#       The cfg$i script should also set $build to "true" or "false"
#       to indicate whether the kernel should be rebuilt and $make
#       to indicate the device config file changed and a make should
#       be done in /sys/cfg.  The cfg$i script is also responsible for
#       making changes to /dev as required.
#
rebuild=false
cfgmake=false
for cfgdev in $list; do
  eval set \$$cfgdev
  vsiz=`expr $1 + 0` export vsiz       # Remove any leading zeroes & export
  int1=`expr $2 + 0` export int1
  int2=`expr $3 + 0` export int2
  int3=`expr $4 + 0` export int3
  int4=`expr $5 + 0` export int4
  set `egrep '^WINI' $CFPROPOSED | wc -l` # Get number of wini's floopy's tape's
  winicount=$1
  set `egrep '^FLOPPY' $CFPROPOSED | wc -l`
  flopcount=$1
  set `egrep '^TAPE' $CFPROPOSED | wc -l`
  tapecount=$1
  export winicount tapecount flopcount
  #
  #     Get the types for each wini.  Floppy is currently fixed
  #     for all drives by 218a limitations, and only one tape drive type
  #     is supported, so we need only ask about winis.
  #     KNOWN:  winicount flopcount tapecount
  #     SET:    wini0 wini1 wini2  . . .
  #
  i=0
  while true; do
    case $i in
      $winicount) break ;;
    esac
    echo -n .
    # Get the /etc/bootcfg id of this wini
    ORIGIFS=$IFS
    IFS=,
    set `egrep "^WINI$i" $CFPROPOSED`
    IFS=$ORIGIFS
    reply=$5
    export reply
    #
    #   Verify drive type exists and reset wini$i
    #
    descr=`( exec < /etc/bootcfg
             while read x; do
               case "$x" in
                 id\ $reply) break ;;
               esac
             done
             while read x y; do
               case "$x" in
                 id)       break ;;
                 mnuentry) continue ;;
                 '*')      break ;;
               esac
               echo -n $x=$y' '
             done
             echo "id=$reply"
           )`
    eval "wini$i='$descr'" export wini$i
    case "$descr" in
      id=$reply) ;;
      *)         i=`expr $i + 1` ;;
    esac
    echo -n .
  done
  echo -n .
  if test -r $SYSCFG/cfg$cfgdev; then
echo "\n
Updating controller configuration files
One moment, please ..."
    SCPSAYS=DOIT
    export SCPSAYS
    $SYSCFG/cfg$cfgdev /tmp/source$$
    if [ -f /tmp/source$$ ] ; then
        .  /tmp/source$$
        rm /tmp/source$$
    fi
    SCPSAYS=
    rm -f /tmp/source$$
    if $build; then
      rebuild=true
    fi
    if $make; then
      cfgmake=true
      rebuild=true
    fi
  fi
  echo -n .
done
#
#       Now that we have fixed the device configuration, we update the
#       cfg library if needed.
#
if $makeok; then
  if $cfgmake; then
    echo -n .
    echo "\nAdding c215g.c to lib_ioc."
    (cd $SYSCFG; $COMMENT make > /dev/null 2>&1)
    echo -n .
  fi
fi
