# Copyright Intel Corp. 1985,1986
# Author:  Ed Reeder
#
# Modified:  Colin Hulme, Intel Corporation
#    4-17-86 to work with Xenix 3.4
#    5/28/87 added notion of PPBOARD to allow hanlding of multiple
#            parallel printers, and to allow configuration (in/out)
#            of the line printer driver in xenixconf
#
# scplp.ss_version[] ="@(#) scplp.ss $State: XENIX_R3-5 $ $Date: 87/06/02 13:31:23 $";

# TO DO:

PPBOARD=0

echo "`date` started parallel printer" >> $ZAPLOG
if [ -f $SWITCHFLAG -o $INITIAL != Y ] ; then
   IFS=,
   set `egrep \^PRINTER$PPBOARD $CFPROPOSED`
   IFS=$ORIGIFS
   PRINTCAPID=$4
   NAME=$5
   while :
      do
      if [ "$NAME" = "none" ] ; then
         echo "\nNo printer is to be connected to the parallel port"
      else
echo "\nPrinter attached to the parallel port
Printer is a $NAME"
      fi
      echo -n 'Is this correct <y/n>? '
      read reply extra
      case "$reply" in
         y*|Y*) echo "`date` ended parallel printer without change" >> $ZAPLOG
                exit $OK ;;
         n*|N*) break ;;
         *) echo Invalid response \<$reply\>, please respecify ;;
      esac
   done
fi

while :
   do
   clear
   cat  <<-HERE
-----------------------------------------------------------------------(Lp)
             Specify parallel printer interface
             (Serial printers are specified elsewhere)

        a)      Printer to be connected via the parallel port 

        n)      No printer to be connected to the parallel port


        q)      Quit to main menu (and lose changes)

        ?)      Get an explanation of these options

HERE
   echo -n "Enter selection? "
   read reply extra
   case "$reply" in


      a|A)
        DEV=/dev/lp
        ;;

      n|N)
        while :
           do
echo -n "No printer is to be connected to the parallel port
Is this correct <y/n>? "
           read reply extra
           case "$reply" in
              y*|Y*)
                 echo Y > $PRINTERFLAG       # indicate printer changed
                 sed "/^PPBOARD$PPBOARD/d;\
                 /^PRINTER$PPBOARD/d" < $CFPROPOSED > $CFPROPOSED\2
                 mv $CFPROPOSED\2 $CFPROPOSED
		 echo "PPBOARD$PPBOARD,none" >> $CFPROPOSED
                 echo "PRINTER$PPBOARD,/dev/lp,$PPLABEL,lp,none,,," >> $CFPROPOSED
                 echo "`date` ended parallel printer" >> $ZAPLOG
                 exit $OK ;;
              n*|N*) continue 2 ;;
              *) echo Invalid response \<$reply\>, please respecify ;;
           esac
        done
        ;;

      # quit
      q*|Q*)
        exit $QUIT
        ;;

      # help
      \?|help|Help)
        clear
        more -c $SCPPATH/scplp.0.hlp
        echo '* * Press RETURN to continue * *'
        read reply
        continue
        ;;
      *)
        echo Invalid response \<$reply\>, Press RETURN to continue
        read reply
        continue
        ;;
   esac

   idx=0
   while :
      do
      clear
      cat  <<-HERE
----------------------------------------------------------------------(Lptype)
                 Specify your type of printer

HERE
      awk -F, '{printf "        %-6s  %s\n",$1,$2}' $SCPPATH/devices/Pprinters$idx
      cat  <<-HERE

        q)      Quit to main menu (and lose changes)
        ?)      Get an explanation of these options

HERE
      echo -n "Enter selection? "
      read reply extra
      case "$reply" in
         # quit
         q*|Q*)
           exit $QUIT
           ;;

         # help
         \?|help|Help)
           clear
           more -c $SCPPATH/scplp.1.hlp
           echo '* * Press RETURN to continue * *'
           read reply
           ;;
         *)
           origreply=$reply
           case $reply in          # Don't allow *
              *\**)  reply=""
           esac
           # only allow numbers, letters, and ?
           reply=`echo $reply | tr -d "[\001-\057][\072-\076]\100[\133-\140][\173-\177]"`
           reply=`echo $reply | tr '[A-Z]' '[a-z]'`   # make lower case
           egrep "^$reply\)," $SCPPATH/devices/Pprinters$idx > /dev/null
           if [ $? -eq 1 -o -z "$reply" ] ; then
              echo "Invalid response <$origreply>, Press RETURN to continue\n"
              read reply
              continue
           fi

           if [ $reply = o ] ; then
              NAME='type unknown'
           else
              IFS=,
              set `egrep "^$reply\)," $SCPPATH/devices/Pprinters$idx`
              NAME=$2
              IFS=$ORIGIFS
           fi

           IFS=,
           set `egrep "^$reply\)," $SCPPATH/devices/Pprinters$idx`
           IFS=$ORIGIFS
           PRINTCAPID=$3 FILTER=$4 SPOOLDIR=$5
           while :
              do
echo -n "\nPrinter attached to the parallel port
Printer is a $NAME
Is this correct <y/n>? "
              read reply extra
              case "$reply" in
                 y*|Y*) break 3 ;;
                 n*|N*) break 2 ;;
                 *) echo Invalid response \<$reply\>, please respecify ;;
              esac
           done
           ;;
      esac
   done
done

echo Y > $PRINTERFLAG       # indicate printer changed
sed "/^PPBOARD$PPBOARD/d;\
/^PRINTER$PPBOARD/d" < $CFPROPOSED > $CFPROPOSED\2
mv $CFPROPOSED\2 $CFPROPOSED
PPTYPE=`gs -l`
echo "PPBOARD$PPBOARD,$PPTYPE" >> $CFPROPOSED
echo "PRINTER$PPBOARD,$DEV,$PPLABEL,$PRINTCAPID,$NAME,$FILTER,$SPOOLDIR" >>$CFPROPOSED

echo "`date` ended parallel printer" >> $ZAPLOG
exit $OK
