: /bin/sh
# Copyright Intel Corp. 1985
# Author:  Colin Hulme
# scplpdflt.ss_version[] ="@(#) scplpdflt.ss $State: XENIX_R3-5 $ $Date: 87/08/07 08:22:08 $";
# Front end script for determining default printer

CASE=$1
ORIGIFS=$IFS

if [ $CASE != "-Make" ] ; then
    $SCPPATH/scplpdmod.ss $CASE		# go and get default from user
    exit $?
fi

[ -f $PRINTERFLAG ] || exit $OK		# exit if no printer changes

# Check if parallel/serial/default printer specifications really changed

grep "^PRINTER"    $CFPROPOSED >/tmp/Pprop
grep "^TPORT.*,P," $CFPROPOSED >/tmp/Sprop
grep "^DFLTPRINT"  $CFPROPOSED >/tmp/Dprop
grep "^PRINTER"    $CURRENT    >/tmp/Pcurr 2>/dev/null
grep "^TPORT.*,P," $CURRENT    >/tmp/Scurr 2>/dev/null
grep "^DFLTPRINT"  $CURRENT    >/tmp/Dcurr 2>/dev/null

cmp /tmp/Pprop /tmp/Pcurr >/dev/null 2>&1
if [ $? -eq 0 ] ; then
    cmp /tmp/Sprop /tmp/Scurr >/dev/null 2>&1
    if [ $? -eq 0 ] ; then
	cmp /tmp/Dprop /tmp/Dcurr >/dev/null 2>&1
	if [ $? -eq 0 ] ; then
	    rm -f $PRINTERFLAG		# false alarm - no printer change
	    exit $OK
	fi
    fi
fi

if [ -s $PRINTERFLAG ] ; then		# need to get default from user
    $SCPPATH/scplpdmod.ss $CASE
    if [ $? -eq $QUIT ] ; then
	exit $QUIT
    fi
fi

set `cat /tmp/Pprop | wc -l`
if [ $1 -eq 1 ] ; then
    IFS=,
    set `cat /tmp/Pprop`
    IFS=$ORIGIFS
    if [ "$5" = "none" -a ! -s /tmp/Sprop ] ; then
	>$PRINTERFLAG
    else
	echo "Y" >$PRINTERFLAG
    fi
else
    echo "Y" >$PRINTERFLAG
fi
