# Copyright Intel Corp. 1985,1986
# Author:  Ed Reeder
#
# Modified:  Colin Hulme, Intel Corporation
#    4-17-86 to work with Xenix 3.4
#
# scpmf.ss_version[] ="@(#) scpmf.ss $State: XENIX_R3-5 $ $Date: 87/02/27 15:52:36 $";

# TO DO:

echo "`date` started max file" >> $ZAPLOG
if [ -f $SWITCHFLAG -o $INITIAL != Y ] ; then
   # read $CFPROPOSED to get the values for max file size
   IFS=,
   exec < $CFPROPOSED
   while :
      do
      read type MAXSIZE
      case "$type" in
         MAXFILE) break ;;
         *) continue
      esac
   done
   IFS=$ORIGIFS         # restore standard internal field separator
   exec < /dev/tty
   while :
      do
echo -n "\nMaximum is $MAXSIZE Megabytes (`expr $MAXSIZE \* 1048576` characters)
Is this correct <y/n>? "
      read reply extra
      case "$reply" in
         y*|Y*) echo "`date` ended max file without change" >>$ZAPLOG
                exit $OK ;;
         n*|N*) break ;;
         *) echo Invalid response \<$reply\>, please respecify ;;
      esac
   done
fi
   
while :
   do
   clear
   cat  <<-HERE
-----------------------------------------------------------------------(Maxfs)
           Specify maximum allowable individual file size

        1   One   Megabyte    (a Megabyte is 1,048,576 characters)
        2   Two   Megabytes
        3   Three Megabytes
        4   Four  Megabytes   (Recommended value)
        5   Five  Megabytes
        6   Six   Megabytes
        7   Seven Megabytes
        8   Eight Megabytes
        9   Nine  Megabytes
       10   Ten   Megabytes

        o)   Other (enter a numeric value for number of Megabytes)
        q)   Quit to main menu (and lose changes)
        ?)   Get an explanation of these options

HERE
   echo -n "Enter selection? (default = 4) "
   read reply extra
   case "$reply" in

      # quit
      q*|Q*)
        exit $QUIT
        ;;

      # help
      \?|help|Help)
        clear
        more -c $SCPPATH/scpmf.0.hlp
        echo '* * Press RETURN to continue * *'
        read reply
        ;;

      *)
	if expr "$reply" : "[oO]*" > /dev/null 2>&1 ; then
		echo -n "enter a numeric value for number of Megabytes: "
		read reply extra
	fi
        if [ x$reply = x ] ; then
            reply=4
        fi
	if expr "$reply" : "[0-9]*$" > /dev/null 2>&1 ; then
		if [ $reply -eq 0 ] ; then
			echo "$reply is too small, Press RETURN to continue"
			read reply
			continue
		fi
			if expr "$reply" : "[0-9]\{5,\}$" > /dev/null 2>&1 ; then
			echo "$reply is too large, Press RETURN to continue"
			read reply
			continue
		fi
		if [ $reply -gt 1023 ] ; then
			echo "$reply is too large, Press RETURN to continue"
			read reply
			continue
		fi
		MAXSIZE=$reply
		echo
		if [ "$reply" != "4" ] ; then
		echo  "$MAXSIZE Megabytes is not the recommended value"
		fi
		while :
		   do
		echo -n "Maximum file size is $MAXSIZE Megabytes (`expr $MAXSIZE \* 1048576` characters)
Is this correct <y/n>? "
		   read reply extra
		   case "$reply" in
		      y*|Y*) break 2 ;;
		      n*|N*) break ;;
		      *) echo Invalid response \<$reply\>, please respecify ;;
		   esac
		done
	else
		echo Invalid response \<$reply\>, Press RETURN to continue
		read reply
	fi

        ;;
   esac
done

if [ -f $SWITCHFLAG -o $INITIAL != Y ] ; then
   sed "/^MAXFILE/c\\
MAXFILE,$MAXSIZE" < $CFPROPOSED > $CFPROPOSED\2
   mv $CFPROPOSED\2 $CFPROPOSED
else
   echo "MAXFILE,$MAXSIZE" >> $CFPROPOSED
fi
echo "Y" > $MAKEFLAG               # make new xenix

echo "`date` ended max file" >>$ZAPLOG
exit $OK

