# Copyright Intel Corp. 1985, 1986
# Author:  Colin Hulme 4-26-86
#
# Modified:
#   10/06/86	Pat Somboonviboon
#		Added XWINI entries as a hook for indicating c215g.c migration.
#    6/09/87	Seckin Unlu
#		Fixed infinite loops for the case of CFPROPOSED not having the
#               CONSOLE, MAXFILE, and/or TIMEZ entries.
#
# scpshow.ss_version[] ="@(#) scpshow.ss $State: XENIX_R3-5 $ $Date: 87/06/09 14:13:33 $";
#
####################### PRINT DISPLAY HEADER ########################
echo "                          CURRENT CONFIGURATION\n"

####################### REVIEW CONSOLE BRAND ########################
IFS=,
exec < $CFPROPOSED
while read type x2 x3 x4 CONLABEL x6 x7 x8 PRINTTERMCAP TYPE
do
    case "$type" in
	CONSOLE)
	    cat  <<-HERE
		Console terminal type specification:
		    Type is $TYPE
HERE
	    break ;;
	*) continue
    esac
done
IFS=$ORIGIFS
exec < /dev/tty
# See if user specified this type "by hand".  If so, show termcap name.
grep ".,$TYPE," $SCPPATH/devices/terminals* > /dev/null
if [ $? -eq 1 ] ; then
    echo "    Terminal name is $PRINTTERMCAP"
fi
#################### DISPLAY WINI AND TAPE INFORMATION #################
wini0=`grep "^WINI0" $CFPROPOSED`
wini_count=0
i=1
temp=\^WINI$i
while grep "$temp" $CFPROPOSED >/dev/null
do
    temp1=`grep "$temp" $CFPROPOSED`
    eval wini$i=\"$temp1\"
    wini_count=`expr $wini_count + 1`
    i=`expr $i + 1`
    temp=\^WINI$i
done
#-------------- get tape configuration information $CFPROPOSED ------------
tape_count=0
i=0
temp=\^TAPE$i
while grep "$temp" $CFPROPOSED >/dev/null
do
    temp1=`grep "$temp" $CFPROPOSED`
    eval tape$i=\"$temp1\"
    tape_count=`expr $tape_count + 1`
    i=`expr $i + 1`
    temp=\^TAPE$i
done
#--------------- Show user current configuration ---------------------
IFS=,
echo "\nPeripheral configuration:"
echo -n "    System Wini 0 -     "
echo $wini0 | awk '{printf $6 " " $7 " " $8 "\n"}'
i=1
while test $i -le $wini_count
do
    echo -n "    Additional Wini $i - "
    temp="\$wini$i"
    eval echo $temp|awk '{printf $6 " " $7 " " $8 "\n"}'
    i=`expr $i + 1`
done
i=0
while test $i -lt $tape_count
do
    echo -n "    Tape $i -            "
    temp="\$tape$i"
    eval echo $temp|awk '{printf $7 " " $8 " " $9 "\n"}'
    i=`expr $i + 1`
done
IFS=$ORIGIFS
if (grep "^XWINI" $CFPROPOSED >/dev/null 2>&1) ; then
	echo "   Add. wini and tape - Information is not available."
	echo "                        Refer to the Release Notes or"
	echo "                        System Admin. Installation Guide."
fi
#################### DISPLAY TIMEZONE INFORMATION #####################
IFS=,
exec < $CFPROPOSED
while read type TIMEZONE DAYLIGHT GMTHOURS
do
    case "$type" in
	TIMEZ)
	    echo -n "\nTime zone is $TIMEZONE, and "
	    if [ $DAYLIGHT -eq 1 ] ; then
		echo 'Daylight Savings time does apply'
	    else
		echo 'Daylight Savings time does not apply'
	    fi
	    [ $GMTHOURS -lt 4 -o $GMTHOURS -gt 11 ] &&
	    echo -n "Time zone is $GMTHOURS hours west of Greenwich Mean Time"
	    break ;;
	*)  continue
    esac
done
IFS=$ORIGIFS
exec < /dev/tty
#################### DISPLAY MAX FILE SIZE #######################
IFS=,
exec < $CFPROPOSED
while read type MAXSIZE
do
    case "$type" in
	MAXFILE)
	    echo "\nMaximum file size is $MAXSIZE Megabytes (`expr $MAXSIZE \* 1048576` characters)"
	    break ;;
	*)  continue
    esac
done
IFS=$ORIGIFS
exec < /dev/tty
#################### DISPLAY LINE PRINTER INFO ###########################
IFS=,
set `egrep \^PRINTER0 $CFPROPOSED`
IFS=$ORIGIFS
PRINTCAPID=$4
NAME=$5
if [ -z "$PRINTCAPID" -o "$NAME" = none ] ; then
    echo "\nNo printer is to be attached to the parallel port"
else
    echo "\nPrinter attached to the parallel port\n Printer is a $NAME"
fi
