# Copyright Intel Corp. 1987
# Original Author: Ed Reeder
#
# Modifications:
#  2-16-87	br
#		there used to be 3 instances of this script, 1 in scpconsole.ss,
#		and 2 in scpport.ss; made it into a separate script.
#  3-19-87	seckin
#		added a top level loop, so that when we prompt the user with the
#		annoying "is this correct ?", and he answers "no", we restart.
#		also, replaced 'clear' with 'echo \n\n...', so that on initial
#		configuration with no console type, the screen gets cleared.
#
# scpterms.ss_version[] ="@(#) scpterms.ss $State: XENIX_R3-5 $ $Date: 87/03/19 13:28:26 $";

while :
   do
   idx=0
   while :
      do
      echo "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n" 
      termname=
      cat  <<-HERE
---------------------------------------------------------------(terminal type)
                    Select the type of terminal

HERE
      awk -F, '{printf "        %-6s  %s\n",$1,$2}' \
         $SCPPATH/devices/terminals$idx
      cat  <<-HERE

HERE
      if [ "$MUSTANSWER" != Y ] ; then
      #put in a blank line to make it look pretty
      cat  <<-HERE
        q)      Quit this menu and continue with system configuration
HERE
	fi
      cat  <<-HERE
        ?)      Get an explanation of these options

HERE
      echo -n "Enter selection? "
      read reply extra
      case "$reply" in
		# help
		\?|help|Help)
			clear
			more -c $SCPPATH/scpterm.0.hlp
			echo '* * Press RETURN to continue * *'
			read reply
			;;

		# allow quit sometimes
		q*|Q*)
			if [ $MUSTANSWER != Y ] ; then
			      exit $QUIT
			fi
	;;
	# All actions checked, see if it is a terminal (or next or other)
		*)
			origreply=$reply
			case $reply in		# Don't allow *
			*\**)  reply=""
	esac
           # only allow numbers, letters, and ?
           reply=`echo $reply | tr -d "[\001-\057][\072-\076]\100[\133-\140][\173-\177]"`
           reply=`echo $reply | tr '[A-Z]' '[a-z]'`   # make lower case
	   egrep "^$reply\)," $SCPPATH/devices/terminals$idx > /dev/null
           if [ $? -eq 1 -o -z "$reply" ] ; then
              echo "Invalid response <$origreply>, Press RETURN to continue\n"
	      read reply
              continue
           fi

           if [ $reply = n ] ; then       # next page selection
              idx=`expr $idx + 1`
              continue
           elif [ $reply = o ] ; then     # other terminal type selection
              while :
                 do
echo "Please enter type and model of terminal, up to 26 characters
__________________________"
                 read TYPE
                 case $TYPE in		# Don't allow *
                    *\**)
                      echo '*\047s are not allowed, please respecify'
                      continue ;;
                    *\?*)
                      echo '?\047s are not allowed, please respecify'
                      continue ;;
                    *\,*)
                      echo ',\047s are not allowed, please respecify'
                      continue ;;
                 esac
                 # filter out any funny regular expression stuff
                 TYPE=`echo "$TYPE" | tr -d '\[\]\\\^\$'`
                 if [ -z "$TYPE" -o "`expr "$TYPE" : '.*'`" -gt 26 ] ; then
                    echo "Invalid response <$TYPE> please respecify"
                    continue
                 else
                    break
                 fi
              done
              while :
                 do
echo -n "Please enter '/etc/termcap' terminal name
Refer to \042XENIX 286 Reference Manual, FILES\042 for more information
Enter terminal name (e.g. wy50) or r to restart terminal specification> "
                 read PRINTTERMCAP
                 case $PRINTTERMCAP in	# Don't allow *, ?, or comma
                    *\**)
                      echo '*\047s are not allowed, please respecify'
                      continue ;;
                    *\?*)
                      echo '?\047s are not allowed, please respecify'
                      continue ;;
                    *\,*)
                      echo ',\047s are not allowed, please respecify'
                      continue ;;
                 esac
                 # filter out any funny regular expression stuff
                 PRINTTERMCAP=`echo "$PRINTTERMCAP" | tr -d '\[\]\\\^\$'`
                 echo $PRINTTERMCAP | egrep "[ 	]" > /dev/null
                 if [ $? -eq 0 ] ; then
                    echo Spaces or tabs not allowed, please respecify
                    continue
                 fi
                 [ ! -z "$PRINTTERMCAP" ] && break
                 echo "Invalid response <$PRINTTERMCAP> please respecify"
                 continue
              done
              if [ $PRINTTERMCAP = r -o $PRINTTERMCAP = R ] ; then
                  exit $RESTART
              fi

              termname=Y	# Indicate user specified a /etc/termcap name

              grep $PRINTTERMCAP /etc/termcap > /dev/null 2>&1
              if [ $? -ne 0 ] ; then
                 echo "
The terminal that you have specified is not supported by the /etc/termcap
file.  You will need to update this file to provide support for this terminal.
SCP will assume an unknown type and will therefore not take advantage of the
terminal's specific capabilities.
* * Press RETURN to continue * *"
                 read reply
                 TYPE="unknown"
                 PRINTTERMCAP="unknown"
              fi
	   elif [ $reply = "r" ] ; then
              idx=`expr $idx - 1`
              continue
           else
              # reply was the name of a terminal
              entry=`egrep "^$reply\)," $SCPPATH/devices/terminals$idx`
              TYPE=`echo $entry | awk -F, '{print $2}'`
              PRINTTERMCAP=`echo $entry | awk -F, '{print $3}'`
           fi
           break
	   ;;
      esac
   done

   # Got a good type, review it
   while :
      do
      echo "\nTerminal type is  $TYPE"
      [ "$termname" = Y ] && echo "terminal name is $PRINTTERMCAP"
      echo -n 'Is this correct <y/n>? '
      read reply extra
      case "$reply" in
         y*|Y*) echo "$TYPE,$PRINTTERMCAP" > $SCPPATH/configurations/term.tmp
	 exit $OK ;;
         n*|N*) continue 2 ;;
         *) echo Invalid response \<$reply\>, please respecify ;;
      esac
   done
done
