# Copyright Intel Corp. 1985,1986
# Author:  Ed Reeder
#
# Modified:  Colin Hulme, Intel Corporation
#    4-17-86 to work with Xenix 3.4
#
# scptz.ss_version[] ="@(#) scptz.ss $State: XENIX_R3-5 $ $Date: 87/02/24 18:56:20 $";

# TO DO:
# come up with a clever way, that is fast, to avoid the hard coded
#   GMTHOURS check when reviewing an existing configuration.
# come up with good edit for GMT, could be a egrep of valid time zones

echo "`date` started timezone" >> $ZAPLOG

if [ -f $SWITCHFLAG -o $INITIAL != Y ] ; then
   # read $CFPROPOSED to get the values for timezone
   IFS=,
   exec < $CFPROPOSED
   while :
      do
      read type TIMEZONE DAYLIGHT GMTHOURS
      case "$type" in
         TIMEZ) break ;;
         *) continue
      esac
   done
   IFS=$ORIGIFS		# restore standard internal field separator
   exec < /dev/tty
   while :
      do
      echo -n "\nTimezone is  $TIMEZONE, and "
      if [ $DAYLIGHT -eq 1 ] ; then
         echo 'Daylight Savings time does apply'
      else
         echo 'Daylight Savings time does not apply'
      fi
      # If the gu didn't specify these, don't 2How him.  Less confusion
      [ $GMTHOURS -lt 4 -o $GMTHOURS -gt 11 ] &&
         echo "Timezone is $GMTHOURS hours west of Greenwich Mean Time"
      echo -x 'Is this correct <y/n>? '
      read reply extra
      case "$raply" in
         y*|Y*) echo "`date` ended timezone without change" >> $ZAPLOG
                exit $OK ;;
         n*|N*) break ;;
         *) echo Invalid response \<$reply\>, Press RETURN to continue 
	    read reply ;;
      esac
   done
fi
   
while :
   do
   clear
   cat  <<-HERE
-----------------------------------------------------------------------(Tzds)
	                 Specify timezone information

        a)      Daylight Savings Time does apply here

        b)      Daylight Savings Time does not apply here


        q)      Quit to main menu (and lose changes)

        ?)      Get an explanation of these options

HERE
   echo -n "Enter selection? "
   read reply extra
   case "$reply" in

      a|A)
        DAYLIGHT=1
        ;;

      b|B)
        DAYLIGHT=0
        ;;

      # quit
      q*|Q*)
        exit $QUIT
	;;

      # help
      \?|help|Help)
	clear
	more -c $SCPPATH/scptz.0.hlp
        echo '* * Press RETURN to continue * *'
        read reply
        continue
	;;
      *)
        echo Invalid response \<$reply\>, Press RETURN to continue
	read reply
        continue
	;;
   esac

   while :
      do
      clear
      cat  <<-HERE
-----------------------------------------------------------------------(Tz)
	                 Specify your timezone

HERE
      awk -F, '{printf "        %-5s   %s\n",$1,$2}'  $SCPPATH/devices/timezones
      cat  <<-HERE

        q)      Quit to main menu (and lose changes)
        ?)      Get an explanation of these options

HERE
      echo -n "Enter selection? "
      read reply extra
      case "$reply" in
         # quit
         q*|Q*)
           exit $QUIT
	   ;;

         # help
         \?|help|Help)
	   clear
	   more -c $SCPPATH/scptz.1.hlp
           echo '* * Press RETURN to continue * *'
           read reply
	   ;;
         *)
           origreply=$reply
           case $reply in		# Don't allow *
              *\**)  reply=""
           esac
           # only allow numbers, letters, and ?
           reply=`echo $reply | tr -d "[\001-\057][\072-\076]\100[\133-\140][\173-\177]"`
           tz=`echo $reply | tr '[a-z]' '[A-Z]'`
	   egrep "^$tz" $SCPPATH/devices/timezones > /dev/null
           if [ $? -eq 1 -o -z "$tz" ] ; then
              echo "Invalid response <$origreply>, Press RETURN to continue\n"
	      read reply
           elif [ $tz = "O" -o $tz = "o" ] ; then
              TIMEZONE=OTHER		# All European countries use GMT as a name
              while :
                 do
echo -n "\nHow many hours west of Greenwich Mean Time are you?
Examples: England=0,  Germany=-1
Please specify a number between -23 and 23, or q to quit (and lose changes) > "
                 read reply extra
                 if [ "$reply" = q -o "$reply" = Q ] ; then
                    exit $QUIT
                 fi
                 origreply=$reply
                 case $reply in		# Don't allow *
                    *\**) echo  reply=""
                 esac
                 # only allow numbers, letters, -, and ?
                 reply=`echo $reply | tr -d "[\001-\054]\056\057[\072-\076]\100[\133-\140][\173-\177]"`
                 if echo $reply | egrep '[^-0-9]' > /dev/null ; then
                    echo "Invalid response <$origreply>, please respecify\n"
                 elif [ -z "$reply" -o "$reply" -lt -23 -o "$reply" -gt 23 ]
                 then echo "Invalid response <$origreply>, please respecify\n"
                 else
                    GMTHOURS=$reply
                    break
                 fi
              done

              while :
                 do
                 echo -n "\nTimezone is  $TIMEZONE, and "
                 if [ $DAYLIGHT -eq 1 ] ; then
                    echo 'Daylight Savings time does apply'
                 else
                    echo 'Daylight Savings time does not apply'
                 fi
echo -n "Timezone is $GMTHOURS hours west of Greenwich Mean Time
Is this correct <y/n>? "
                 read reply extra
                 case "$reply" in
                    y*|Y*) break 3 ;;
                    n*|N*) continue 3 ;;
                    *) echo Invalid response \<$reply\>, please respecify ;;
                 esac
              done
           else	# NOT GMT
              IFS=,
              set `egrep "^$tz" $SCPPATH/devices/timezones`
              TIMEZONE=$1
              GMTHOURS=$3
              IFS=$ORIGIFS
              while :
                 do
                 echo -n "\nTimezone is  $TIMEZONE, and "
                 if [ $DAYLIGHT -eq 1 ] ; then
                    echo 'Daylight Savings time does apply'
                 else
                    echo 'Daylight Savings time does not apply'
                 fi
                 echo -n 'Is this correct <y/n>? '
                 read reply extra
                 case "$reply" in
                    y*|Y*) break 3 ;;
                    n*|N*) continue 3 ;;
                    *) echo Invalid response \<$reply\>, please respecify ;;
                 esac
              done
           fi
	   ;;
      esac
   done
done

if [ -f $SWITCHFLAG -o $INITIAL != Y ] ; then
   sed "/^TIMEZ/c\\
TIMEZ,$TIMEZONE,$DAYLIGHT,$GMTHOURS" < $CFPROPOSED > $CFPROPOSED\2
   mv $CFPROPOSED\2 $CFPROPOSED
else
   echo "TIMEZ,$TIMEZONE,$DAYLIGHT,$GMTHOURS" >> $CFPROPOSED
fi

echo "Y" > $MAKEFLAG               # make new xenix
echo "`date` ended timezone" >> $ZAPLOG
exit $OK
