/*
 *	control sequences for CIE-300
 *
 *      Copyright 1985, Intel Corporation.
 *
 *	note:
 *		does not include vertical format specifications,
 *		
 *		or dot corresponding graphics mode
 *		Also, if an on seq. is used as an off seq., it must
 *		appear after the on seq in the table.
 *		Example, Printers char set 1 is def char set, and appears
 *		after all the other char sets in the table
 *
 *	ci300ctl.c
 *
 *	Written by David Callahan for Intel 05/08/85
 */


static char ci300ctl_version[] ="@(#) ci300ctl $State: XENIX_R3-5 $ $Date: 86/05/30 08:43:58 $";

#include "ilpf.h"

struct escseq esctab[] = {
	0,3,3,0,0,"\33\60\41","\33\60\40",	/* 5 CPI */
	0,3,3,0,0,"\33\60\43","\33\60\40",	/* 2.5 CPI */
	0,3,3,0,0,"\33\60\47","\33\60\40",	/* 1.25 CPI */
	0,3,3,0,0,"\33\60\40","\33\60\40",	/* 10 CPI */
	0,3,3,0,0,"\33\61\41","\33\61\40",	/* 2x height char's */
	0,3,3,0,0,"\33\61\43","\33\61\40",	/* 4x height char's */
	0,3,3,0,0,"\33\61\47","\33\61\40",	/* 8x height char's */
	0,3,3,0,0,"\33\61\40","\33\61\40",	/* 1x height char's */
	0,3,3,0,0,"\33\62\41","\33\62\40",	/* underline */
	0,3,3,0,0,"\33\63\41","\33\63\40",	/* bold */
	0,3,3,0,0,"\33\63\42","\33\63\40",	/* italics */
	0,3,0,0x20,0x7e,"\33\74\33","",		/* line skip count */
	0,3,3,0,0,"\33\76\41","\33\76\40",	/* reset or write in EAROM */
	0,4,4,0x20,0x7e,"\33?\40\33","\33?\40a",/* form length */
	0,4,4,0x20,0x23,"\33?!\33","\33?!\42",	/* line pitch */
	0,4,4,0x20,0x23,"\33?\42\33","\33?\42\40",	/* char pitch */
	0,4,4,0x20,0x22,"\33?#\33","\33?#\40",	/* print density */
	0,4,4,0x20,0x2b,"\33?$\33","\33?$\40",	/* character set */
	0,4,4,0x20,0x22,"\33?%\33","\33?%\42",	/* 0 and o form setting */
	0,4,4,0x20,0x22,"\33?&\33","\33?&\41",	/* max print col (10 CPI) */
	0,4,4,0,0,"\33?'\40","\33?'\41",	/* max print col (condensed) */
	0,4,4,0,0,"\33?(\40","\33?(\41",	/* ruled line/block char */
	0,4,4,0,0,"\33?*\41","\33?*\40",	/* shuttle direction */
	0,4,4,0x20,0x27,"\33?+\33","\33?+\20",	/* perforated skip amount */
	0,4,4,0,0,"\33?,\21","\33?,\20",	/* shuttle stop-time */
	0,4,4,0x20,0x22,"\33?_\33","\33?_\40",	/* on/off line at alarm */
	0,4,4,0x20,0x24,"\33?.\33","\33?.\40",	/* oper. after paper near end alarm */
	0,4,4,0x20,0x22,"\33?/\33","\33?/\41",	/* oper for top cover alarm */
	0,4,4,0x20,0x23,"\33?0\33","\33?0\40",	/* print start setting */
	0,4,4,0x20,0x23,"\33?1\33","\33?1\40",	/* VFU selection */
	0,4,4,0x20,0x22,"\33?2\33","\33?2\40",	/* selection of BOF */
	0,4,4,0,0,"\33?3\40","\33?3\41",	/* on/off line mode selection */
	0,4,4,0x20,0x22,"\33?5\33","\33?5\40",	/* on/off line change-over */
	0,4,4,0,0,"\33?6\41","\33?6\40",	/* LF,FF switch func. in online */
	0,4,4,0,0,"\33?7\41","\33?7\40",	/* slew speed */
	TABEND,0,0,0,0,"0","0" };

unsigned char 	escs[] = "\33 ";

char	cntlcd[] = "\13\16\17\21\23\30";
/**	\13		vertical tab
	\16		shift char set
	\17		clears shift out
	\21		on-line mode
	\23		off-line mode
	\30		cancel	**/
