/*
 *	control sequences for Silver Reed EXP 770
 *	
 *      Copyright 1985, Intel Corporation.
 *
 *	exp770ctl.c
 *
 *	written by David Callahan for Intel		05/09/85
 */


static char exp770ctl_version[] ="@(#) exp770ctl $State: XENIX_R3-5 $ $Date: 86/05/30 08:42:54 $";
#include "ilpf.h"

struct escseq esctab[] = {
	0,2,2,0,0,"\33W"	,"\33&",	/* double strike */
	0,2,2,0,0,"\33\71"	,"\33\71",	/* set left margin */
	0,2,0,0,0,"\33\60"	,"",		/* set right margin */
	0,2,2,0,0,"\33T"	,"\33C",	/* set top page margin */
	0,2,2,0,0,"\33L"	,"\33C",	/* set bottom page margin */
	0,2,2,0,0,"\33\61"	,"\33\70",	/* set horizontal tab */
	0,2,2,0,0,"\33-"	,"\33\62",	/* set vertical tab */
	0,3,0,0x1,0x7e,"\33\13\33","",		/* absolute vertical tab */
	0,2,0,0,0,"\33\62"	,"",		/* clear all tabs */
	0,3,3,0x1,0x7e,"\33\14\33","\33\14\102",/* lines per page */
	0,3,2,0x2,0x7e,"\33\37\33","\33S",	/* spacing pitch */
	0,3,0,0x0,0x7e,"\33\11\33","",		/* absolute horizontal tab */
	0,2,2,0,0,"\33?"	,"\33!",	/* auto carriage return */
	0,2,2,0,0,"\33<"	,"\33>",	/* reverse printing mode */
	0,2,2,0,0,"\33\57"	,"\33\134",	/* auto backward printing */
	0,2,2,0,0,"\33\66"	,"\33\65",	/* backward printing */
	0,2,0,0,0,"\33\10"	,"",		/* backspace 1/120 inch */
	0,2,2,0,0,"\33P"	,"\33Q",	/* proportional space printing */
	0,2,2,0,0,"\33%"	,"\33N",	/* inc carriage settling time */
	0,3,3,0x2,0x7e,"\33\36\33","\33\36\10",	/* line feed spacing */
	0,2,0,0,0,"\33U"	,"\33U",	/* superscript */
	0,2,0,0,0,"\33D"	,"\33D",	/* subscript */
	0,2,0,0,0,"\33\12"	,"",		/* negative line feed */
	0,2,2,0,0,"\33E"	,"\33R",	/* underscore */
	0,2,2,0,0,"\33O"	,"\33&",	/* bold */
	0,2,2,0,0,"\33M"	,"\33X",	/* auto justification */
	0,2,2,0,0,"\33="	,"\33X",	/* auto centering */
	0,3,2,0,0xff,"\33\21\33","\33X",	/* offset selection */
	0,3,0,0,0,"\33\15P"	,"",		/* initial remote reset */
	0,2,0,0,0,"\33Y"	,"",		/* print 0x20 and 0x7f */
	0,2,0,0,0,"\33Z"	,"",		/* print 0x20 and 0x7f */
	TABEND,1,1,0,0,"0","0" };

unsigned char 	escs[] = "\33 ";

char	cntlcd[] = "\7\013\023";
/**	\7,			audible alarm
	\017,			vertical tab
	\023,			stop printing	**/
