/*
 *	control sequences for Smith Corona FASTEXT 80
 *	
 *      Copyright 1985, Intel Corporation.
 *
 *	note:  does not include reverse feed or TAB entries
 *		If an on seq. is used as an off seq., then
 *		it should appear in the table after the last
 *		occurance of it in the off seq.
 *
 *	scd80ctl.c
 *
 *	Written by Ed Reeder for XENIX286  04/23/85
 *
 *	Modified by Ralph Sydnor for Intel		08/12/85
 */


static char scd80ctl_version[] ="@(#) scd80ctl $State: XENIX_R3-5 $ $Date: 86/05/30 08:44:30 $";
#include "ilpf.h"

struct escseq esctab[] = {
	0,2,2,0,0,"\033E"	,"\033F",	/* emphasized  */
	0,2,2,0,0,"\033M"	,"\033P",	/* compressed  */
	0,2,2,0,0,"\033G"	,"\033H",	/* doublestrike */
	0,3,3,0,0,"\33-\01"	,"\33-\00",	/* underline */
	0,3,3,0,0,"\33-\61"	,"\33-\60",	/* underline */
	0,3,2,0,0,"\033S\00"	,"\033T",	/* superscript */
	0,3,2,0,0,"\033S\060"	,"\033T",	/* superscript */
	0,3,2,0,0,"\033S\01"	,"\033T",	/* subscript */
	0,3,2,0,0,"\033S\061"	,"\033T",	/* subscript */
	0,2,2,0,0,"\033\00"	,"\033\02",	/* 1/8 inch line spacing */
	0,2,2,0,0,"\033\01"	,"\033\02",	/* 7/72 inch line spacing */
	0,3,3,0,0,"\033U\01"	,"\033R\00",	/* unidirectional print */
	0,3,3,0,0,"\033U\061"	,"\033R\060",	/* unidirectional print */
	0,2,2,0,0,"\033\06"	,"\033\07",	/* printable code area */
	0,2,2,0,0,"\033="	,"\033#",	/* MSB = 0   */
	0,2,2,0,0,"\033>"	,"\033#",	/* MSB=1 */
	0,2,1,0,0,"\033\016"	,"\024",	/* elongated   */
	0,2,1,0,0,"\033\017"	,"\022",	/* condensed */
	0,3,3,0,0,"\033I\01"	,"\033I\00",	/* control code selection */
	0,3,3,0,0,"\033I\061"	,"\033I\060",	/* control code selection */
	0,3,3,0,0,"\033p\01"	,"\033p\00",	/* proportional spacing */
	0,3,3,0,0,"\033p\061"	,"\033p\060",	/* proportional spacing */
	0,3,3,0,0,"\033W\01"	,"\033W\00",	/* enlarged */
	0,3,3,0,0,"\033W\061"	,"\033W\060",	/* enlarged */
	0,2,2,0,0,"\033;"	,"\033P",	/* near letter qual */
	0,2,2,0,0,"\033\04"	,"\033\05",	/* italics   */
	0,2,2,0,0,"\033\08"	,"\033\09",	/* deselect/select paper end */
	0,2,0,0,0,"\033<"	,"",		/* print left to right */
	0,2,0,0,0,"\033@"	,"",		/* printer initialization */
	0,3,0,0,0x7f,"\033!\033"	,"",	/* print mode */
	0,5,0,0,0xff,"\033*\00\033\033"	,"",	/* 8-pin bit image */
	0,5,0,0,0xff,"\033*\01\033\033"	,"",	/* 8-pin bit image */
	0,5,0,0,0xff,"\033*\02\033\033"	,"",	/* 8-pin bit image */
	0,5,0,0,0xff,"\033*\03\033\033"	,"",	/* 8-pin bit image */
	0,4,0,0,0xff,"\033K\033\033"	,"",	/* normal density bit image */
	0,4,0,0,0xff,"\033L\033\033"	,"",	/* dual density bit image */
	0,4,0,0,0xff,"\033Y\033\033"	,"",	/* DS dual density bit image */
	0,4,0,0,0xff,"\033Z\033\033"	,"",	/* quad density bit image */
	0,3,0,0x0,0xff,"\033J\033"	,"",	/* paper feed execution */
	0,3,0,0x0,0xd8,"\033l\033"	,"",	/* left margin setting */
	0,3,0,0x1,0x6e,"\033Q\033"	,"",	/* column width */
	0,3,2,0x1,0xff,"\033\03\033"	,"\033\02",	/* n/144 inch line spacing */
	0,3,2,0x1,0x7f,"\033N\033"	,"\033O",	/* skip over perforation */
	0,3,3,0x1,0x48,"\033C\033"	,"\033C\102",	/* form length by lines */
	0,4,3,0x1,0x26,"\033C\00\033"	,"\033C\102",	/* form length by inches */
	0,3,2,0x1,0x55,"\033A\033"	,"\033\02",	/* line space setting */
	0,3,3,0,0x07,"\033R\033"	,"\033R\00",	/* international char set */
	TABEND,1,1,0,0,"0","0" };

unsigned char 	escs[] = "\033 ";

char	cntlcd[] = "\017\020\021\022\023\024\030";
/**	\017,			 condensed on
	\020,			 elongate on
	\021,			 select printer
	\022,			 condensed off
	\023,			 deselect printer
	\024,			 elongate off
 	\030			 cancel		**/
