
/*
 * "@(#) bblock $State: XENIX_R3-5 $ $Date: 86/05/30 13:00:38 $"
 */

/*
 *	INTEL CORPORATION PROPIETARY INFORMATION
 *
 *	This software is supplied under the terms
 *	of a license agreement or nondisclosure
 *	agreement with Intel Corporation and may
 *	not be copied nor disclosed except in
 *	accordance with the terms of that agreement.
 */

/**********************************************************************
 *
 * TITLE:	Bad Block 
 *
 * DATE:	February 25, 1985
 *
 * AUTHOR:	Richard N. Bryant
 *
 * SUMMARY:
 *	Bad Block Include File
 *
 **********************************************************************/



/*
 * Bad block structure of data in error partition.
 */
struct	BB_fmt {
	union u_BB {
		struct h_B {
			ushort		h_id;
			daddr_t		h_index;
		}h_B;
		struct d_B {
			unsigned char	d_stat;
			unsigned char	d_part;
			daddr_t		d_blkno;
		}d_B;
	}u_BB
};


#define	bh_id		u_BB.h_B.h_id
#define	bh_index	u_BB.h_B.h_index

#define	bd_stat		u_BB.d_B.d_stat
#define	bd_part		u_BB.d_B.d_part
#define	bd_blkno	u_BB.d_B.d_blkno



/* 
 * Define constant values used by the Bad Block utility
 * and device drivers.
 */

/*
 * Bad block partition header ID
 * initialization flag.
 */
#define	BB_ID		0xBADB

/*
 * Bad block error status flags
 */
#define	BB_WRITE	1
#define	BB_READ		2
#define	BB_SOFT		4
#define	BB_HARD		8
#define BB_FIXED	128

/*
 * Bad block partition data types
 */
#define	BB_HEADER	1
#define	BB_DATA		2



/*
 * Structure to hold bad block information.
 */
struct	BB_ioc {
	unsigned char	bi_stat;
	unsigned char	bi_part;
	daddr_t		bi_blkno;
};

/* Bad Block command to block device "proc" function */
#define	BAD_BLOCK	(('B'<<8)|1)


