
/*
 * "@(#) i286instr $State: XENIX_R3-5 $ $Date: 86/05/30 01:14:03 $"
 */

|
|	@(#) mdep/i286instr.h 1.3 84/05/07 Copyright Microsoft Corporation, 1983
|
|	This Module contains Proprietary Information of Microsoft
|	Corporation and AT&T, and should be treated as Confidential.
|
|
| THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
| INTEL 80286 CPU. IT IS NOT PORTABLE TO OTHER
| ARCHITECTURES.
|
|##
|## definition of 286 descriptor table managment instructions
|## uses the c preprocessor
|##
|## define register fields
#define	Rax	/00
#define	Rcx	/01
#define	Rdx	/02
#define	Rbx	/03
#define	Rsp	/04
#define	Rbp	/05
#define	Rsi	/06
#define	Rdi	/07

|## Load/Store descriptor table instructions
|##  Each loads from memory location Y
|##
#define LIDT(Y) |Lidt(Y) ##NL .byte /0f, /01, /1e ##NL .word #Y
#define LGDT(Y) |Lgdt(Y) ##NL .byte /0f, /01, /16 ##NL .word #Y
#define LGDTR(Reg) |Lgdtr(Reg) ##NL \
	.byte /0f, /01, /d0 + Reg 
#define LLDT(Y) |Lldt(Y) ##NL .byte /0f, /00, /16 ##NL .word #Y
#define LLDTR(Reg) |Lldtr(Reg) ##NL \
	.byte /0f, /00, /d0 + Reg 
#define SIDT(Y)	|Sidt(Y) ##NL .byte /0f, /01, /06 ##NL .word #Y
#define SGDT(Y)	|Sgdt(Y) ##NL .byte /0f, /01, /0e ##NL .word #Y
#define SLDT(Y)	|Sldt(Y) ##NL .byte /0f, /00, /06 ##NL .word #Y
#define SLDTR(Reg) |Sldtr(Reg) ##NL .byte /0f, /00, /c0 + Reg
#define LTRR(Reg)	|Ltr(Y) ##NL .byte /0f, /0, /d8+Reg
|##
|## Load/store the machine status word
|##  Y defines an Offset in the current ds
|##
#define LMSW(Y) |Lmsw(Y) ##NL .byte /0f, /01, /36 ##NL .word #Y
#define LMSWR(Reg) |Lmswr(Reg) ##NL .byte /0f, /01, /f0 + Reg
#define SMSW(Y) |Smsw(Y) ##NL .byte /0f, /01, /26 ##NL .word #Y
#define SMSWR(Reg) |Smswr(Reg) ##NL .byte /0f, /01, /e0 + Reg
|##
|## Adjust Privilidge level
|##  not implemented
#define ARPL(Y)	error --- arpl not yet implemented
|##
|## Clear task switched flag
#define CLTS		.byte /0f, /06
|##
|## load acc rights, seg limit, task reg
|## not implemented
#define LAR(Y)	error --- Lar not yet implemented
#define LSL(Y)	error --- Lsl not yet implemented
|##
|## pop/push all regs
#define POPA		.byte /61
#define PUSHA		.byte /60
|##
|## push immediate
#define	PUSHI(val)	|pushi(val) ##NL .byte /68 ##NL .word #val
#define	PUSHIB(val)	|pushi(val) ##NL .byte /6A ##NL .byte #val
|##
|##
#define	SHRI(Reg,Cnt)	|shri(Reg,Cnt) ##NL .byte /C1, /E8+Reg, Cnt
#define	SHLI(Reg,Cnt)	|shli(Reg,Cnt) ##NL .byte /C1, /E0+Reg, Cnt
|##
|## verify a Segment for read/write
#define VERR(Y)	|Verr(Y) ##NL .byte /0f, /00, /26 ##NL .word #Y
#define VERW(Y)	|Verw(Y) ##NL .byte /0f, /00, /2e ##NL .word #Y
|##
|## intersegment call 
#define	CALLIG	/09A
