/*
 *	 INTEL CORPORATION PROPRIETARY INFORMATION
 *
 *	This software  is supplied  under the terms
 *	of a  license  agreement  or  nondisclosure
 *	agreement  with Intel Corporation  and  may
 *	not  be  copied  nor  disclosed  except  in
 *	accordance with the terms of that agreement.
 *
 *      Copyright 1987 Intel Corporation
 */

/*
 * "@(#) iapx386.h $State: XENIX_R3-5 $ $Date: 87/04/07 17:46:01 $"
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * INTEL 80286/386 CPU AND MAY REQUIRE MODIFICATION
 * WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

/*
 * Modification History
 *
 *	created	br	11/06/86
 *		declarations for structures and externs for
 *		80286/386 processor and hardware dependencies
 *
 *	i001	br	01/28/87
 *		added support for "gs"
 *		completely redefined hw_config struct.
 *		now we have to be very careful in setting up the
 *		structure.
 *		we have been granted the space from 0x1740 thru
 *		0x17ff.  use it wisely.
 */

#define	HW_CONFIG_LOC 0x1740	/* absolute locations in memory   */
				/* for hardware config values */
#define HW_TOP_CONFIG 0x17ff
#define HW_MAX_CONTROLLERS 8

struct	hw_controller{
	int type;
	int vrs;
	int no_devices;
	long dev_addr;
	unsigned dev_port;
	int int_level;
};
struct	hw_config {
	int	processor_type;	/* this MUST be guaranteed to be
				 * at 0x1740 !!!!!!!!!!!!
				 * values: 0(for 286) or 0x386(for 386)
				 */
	int	coprocessor_type;	/* values: 0(no ndp), 0x287(for
					 * 287), or 0x387(for 387)
					 */
	int	mem_size;		/* in Kbytes */
	char	kernel_state[24];
	char	kernel_gen_date[8];
	char	boot_path[40];
	struct	hw_controller controller[HW_MAX_CONTROLLERS];
	};

extern	int	iapx386;
extern	int	test_386();
