
/*
 * "@(#) ovl $State: XENIX_R3-5 $ $Date: 86/05/30 13:04:45 $"
 */

/*
 *	Definitions for the overlay table and TSS
 */

/*
 *  The structure of the overlay table is as follows -
 *	struct ovltable {
 *		struct ovlhdr ovlhdr;
 *		struct ovlent ovlent[];
 *		char   stringspace[];
 *	}
 */

struct ovlhdr {
	short	oh_size;		/* size of entire table */
	short	oh_numovls;		/* number of overlays, including root*/
	long	oh_minmem;		/* mem requirements of the root */
	long	oh_maxmem;		/* max mem requirements of any path in
					   the ovl tree from root to leaf */
	char	oh_res[20];		/* reserved */
};


struct ovlent {
	short	o_name;			/* ptr to name in string space */
	short	o_parent;		/* offset of parent in overlay table */
	struct	seglist {
		short	o_numsegs;	/* number of segments in this overlay */
		short	o_index;	/* ptr to segment list in string space*/
	} o_seglist;
	long	o_begfix;		/* pointer to start of fixup */
	long	o_endfix;		/* pointer to end of fixup */
	char	o_res[16];		/* reserved */
};

#define STRSZ		32

/* Now the TSS */

struct tss {
	short t_bklink;			/* back link */
	short t_spcl0;			/* sp for cpl0 */
	short t_sscl0;			/* ss for cpl0 */
	short t_spcl1;			/* sp for cpl1 */
	short t_sscl1;			/* ss for cpl1 */
	short t_spcl2;			/* sp for cpl2 */
	short t_sscl2;			/* ss for cpl2 */
	short t_ip;			/* ip */
	short t_flag;			/* flag */
	short t_ax;			/* ax */
	short t_cx;			/* cx */
	short t_dx;			/* dx */
	short t_bx;			/* bx */
	short t_sp;			/* sp */
	short t_bp;			/* bp */
	short t_si;			/* si */
	short t_di;			/* di */
	short t_es_sel;			/* es selector */
	short t_cs_sel;			/* cs selector */
	short t_ss_sel;			/* ss selector */
	short t_ds_sel;			/* ds selector */
	short t_tskldt;			/* task ldt selector */
};

#define	HI_BIT		0x80000000L		/* most significant bit */
